ビルドについて
==============

プロジェクトをビルドするには、cc65とmsysのインストールと環境変数の設定が必要です。

配布時は、以下のディレクトリ構成を想定しています。

	c:\home\fwc           ... プロジェクトを含むディレクトリ

	c:\home\fwc\iceballer ... プロジェクトディレクトリ

	c:\home\fwc\nsdl      ... NES Sound Driver Library のディレクトリ

	c:\cc65               ... cc65のコンパイラ、ライブラリのディレクトリ

	c:\MinGW\msys         ... msysのディレクトリ

	c:\opt\virtualnes     ... VirtuaNESのディレクトリ（動作確認用でビルドには不要）


各自のインストール先に応じて setenv.bat を編集し、
コマンドプロンプト上にてビルド作業を行う前に一度だけ実行してください。

後は、各プロジェクト配下で、make を実行すればビルドできます。

なお、VirtuaNES のパスが設定されていれば、make run で自動実行できます。

操作手順の例：

	> setenv
	> make

Makefileはmsys及びWindows依存です。
LinuxやMacで利用する場合は、適宜修正してください。


カスタマイズ
------------

### build.def

makeを実行する際、build.defを書き換える事で定数定義を外部から指定できます。

現在テンプレートとして用意しているのは、以下の定義ファイルです。ファイル名を build.def に変更して使います。

* build-normal.def  サウンドありの通常コンパイル用
* build-silent.def  サウンドなしのコンパイル用
* build-padrec.def  プレイデモ記録用（１シーン分のパッド入力情報を1P側0x7000から、2P側0x7800から記録）


### シーンマップの変更方法

シーンのマップ情報は、map.c の 322行目あたりからバイト配列で用意しています。  
１シーンは横12マス、縦11マスから構成されており、全30シーンです。  
277行目あたりで定義しているシンボル定義の文字列（_ や Oなど）を配置してコンパイルしなおしてください。  
LEVEL B の場合は、スライムとウィザードが、強制的に赤スライムとソーサラーに置き換わります。

テキストエディタで xyzzy を利用されている方は、コメント側を修正後、マクロ実行で配列側に反映することができます。
1. M-x: load-file にて、cmt2map.l のLispファイルを読み込む
2. メインメニュー>ツール>キーボードマクロおまけ>読み込み を選択
3. cmt2map を選択し、読み込みボタンを押下
4. 変更したコメントのある行の**先頭**でマクロ実行

#### 注意

* キャラクタはNPC含めて8体まで配置できますが、画面中に魔法の玉が２つまでなので魔術師の配置時に注意してください。
* 水平方向にキャラクタを4体並べると、ブリンク制御を行っていないため5体目以降が表示されません。
* エラーチェックはほとんどありませんので、クリア不可能あるいは実行不可能なマップにならないよう注意してください。
* プレイデモのシーンを変更した場合、恐らくクリアできなくなります。プレイデモ用にコンパイルしたバージョンをエミュレータにて実際にプレイし、メモリビュアーやステータスセーブファイルよりパッド情報を取得して、demo.c の冒頭にある配列へセットしてください。


---
Copyright &copy; 2015 @MIRROR_  
[ムトー研究所]: http://homepage2.nifty.com/jyube/muto/
