/*
 * chara.h
 *
 * Last modified: <2014/12/19 23:40:32 +0900> By @MIRROR_
 */
#ifndef CHARA_H_INCLUDED
#define CHARA_H_INCLUDED

#include "vector.h"

#define STATUS_BUSY      0x80
#define STATUS_GOAL      0x40
#define STATUS_LEAP      0x20
#define STATUS_LOOP      0x10
#define STATUS_RESET     0x08
#define STATUS_BALL      0x04
#define STATUS_CONFUSION 0x02
#define STATUS_KICK      0x01

#define CHARA_MAX        10
#define CHARA_P1          0
#define CHARA_P2          1
#define CHARA_ENEMY_TOP   2
#define CHARA_ENEMY_BTM   8
#define CHARA_ID_MAX      8

#define BALL_MAX          1

#define FIRE_BALL_TOP     8

// LN^ID
enum {
	CHR_BLUE_PENGUIN = 0,
	CHR_RED_PENGUIN,
	CHR_PLAYERS = CHR_RED_PENGUIN,
	CHR_SLIME,
	CHR_WIZARD,
	CHR_RED_SLIME,
	CHR_SORCERER,
	CHR_PC_NPC_MAX,
	CHR_FIRE_BALL = CHR_PC_NPC_MAX,
	CHR_REVERSE_BALL,
	CHR_MAX,
	CHR_NOTHING = 0xff
};

// 
typedef struct Direction {
	unsigned char cur;   // ݂̌
	unsigned char ext;   // Ǒ
} Direction;

// ړp[^iAj
typedef union MovePrm {
	Direction dir;
	Vector    vec;
} MovePrm;

// LN^
typedef struct Chara {
	unsigned char id;     // }bvID
	unsigned char chr;    // LN^ԍ
	unsigned char status; // ԃtO
	unsigned char action; // ID
	unsigned char x, y;   // ʒu Œ菬 nnnn.nnnn
	MovePrm       move;   // ړp[^
} Chara;

// {[
typedef struct Ball {
	unsigned char status;
	unsigned char x;
	unsigned char y;
	unsigned char dir;
} Ball;

extern Chara chara[CHARA_MAX];
extern Ball ball[BALL_MAX];

extern void __fastcall__ chara_init(void);
extern void __fastcall__ chara_draw(unsigned char frame);
extern void __fastcall__ chara_action_move(Chara* p);
extern char __fastcall__ chara_action_leap(Chara* p, unsigned char dir, unsigned char status);

extern void __fastcall__ action_penguin(Chara* p);
extern void __fastcall__ action_slime(Chara* p);
extern void __fastcall__ action_wizard(Chara* p);
extern void __fastcall__ action_masic_ball(Chara* p);

extern void __fastcall__ action_ball(Ball* b);

#endif
