/*
 * game.h
 *
 * Last modified: <2014/12/30 23:16:45 +0900> By @MIRROR_
 */
#ifndef GAME_H_INCLUDED
#define GAME_H_INCLUDED

#define SCENE_MAX 30
#define SCENE_START_WAIT 120
#define SCENE_GOAL_WAIT  6
#define SCENE_OVER_WAIT  120

#define SPR_FONT_TOP 0xb0

#define sprint(_x, _y, _str) \
{ \
	unsigned char x = _x; \
	unsigned char y = _y; \
	unsigned char i; \
	for (i = 0; _str[i] != 0; ++i) { \
		if (_str[i] != ' ') SetDMA(x + (i<<3), y, _str[i] - '0' + SPR_FONT_TOP, 0); \
	} \
}

#define sprint_n2(_x, _y, _val) \
{ \
	unsigned char x = _x; \
	unsigned char y = _y; \
	unsigned char v0 = (_val) / 10; \
	unsigned char v1 = (_val) % 10; \
	if (v0 > 0) {SetDMA(x, y, v0 + SPR_FONT_TOP, 0); x+=8;} \
	SetDMA(x, y, v1 + SPR_FONT_TOP, 0); \
}

#define sprint_n02(_x, _y, _val) \
{ \
	unsigned char x = _x; \
	unsigned char y = _y; \
	unsigned char v0 = (_val) / 10; \
	unsigned char v1 = (_val) % 10; \
	SetDMA(x    , y, v0 + SPR_FONT_TOP, 0); \
	SetDMA(x + 8, y, v1 + SPR_FONT_TOP, 0); \
}

enum {
	GAME_TASK_START = 0,
	GAME_TASK_PLAY,
	GAME_TASK_GOAL,
	GAME_TASK_CLEAR,
	GAME_TASK_OVER,
	GAME_TASK_CONGRATULATION,
	GAME_TASK_MAX
};

enum {
	GAME_STATUS_PAUSE = 0x80,
	GAME_STATUS_EXCHANGE = 0x40,
	GAME_STATUS_PLAYDEMO = 0x20
};

typedef struct GamePrm {
	unsigned char level;
	unsigned char scene;
	unsigned char frame;
	unsigned char task;
	unsigned char status;
	unsigned char time, tcnt;
	unsigned char ecnt;
} GamePrm;

extern GamePrm game;

extern const unsigned char msg_scene[];
extern const unsigned char msg_clear[];
extern const unsigned char msg_over[];
extern const unsigned char msg_pause[];
extern const unsigned char msg_congraturation[];

#endif
