/*
 * map.c
 *
 * Last modified: <2014/12/25 22:26:00 +0900> By @MIRROR_
 */
#include "nes.h"
#include "game.h"
#include "chara.h"
#include "map.h"
#include "palette.h"

// }bv`bv
const unsigned char mapchips[][4]  = {
	{0x00,0x00,0x00,0x00}, // Ƃ
	{0x18,0x19,0x1a,0x1b}, // ]{[
	{0x1c,0x1d,0x1e,0x1f}, // S[̊
	{0x14,0x15,0x16,0x17}, // X̃L[u
	{0x0c,0x0c,0x0c,0x0c}, // 󂹂ubN
	{0x0c,0x0c,0x0c,0x0c}, // ubN
	{0x14,0x15,0x16,0x17}, // 
};

// BGe[u
const unsigned char attrbg[] = {
	0x02, // Ƃ
	0x02, // ]{[
	0x02, // S[̊
	0x00, // X̃L[u
	0x01, // 󂹂ubN
	0x00, // ubN
	0x03, // 
};

// }bve[u
extern const unsigned short maps[];

// }bvV{擾
extern unsigned char __fastcall__ map_get_symbol(unsigned char c);

// Q[̃}bv
unsigned char gamemap[MAP_FIELD_H][MAP_FIELD_W];

// e[u
unsigned char attrtbl[BG_ATTR_H][BG_ATTR_W];

// ݂̃}bv
unsigned char* map;

void map_init(char scene) {

	// pbgݒ
	SetPalette(palettebg, 0);

	// wiݒ
	FillNameTbl( 0,  0, 32, 30, 0x03); /* C   */
	FillNameTbl( 4,  4, 24, 22, 0x00); /* X */
	FillNameTbl( 4,  3, 24,  1, 0x0a); /* [ */
	FillNameTbl( 4, 26, 24,  1, 0x0b); /* [ */
	FillNameTbl( 3,  4,  1, 22, 0x09); /* [ */
	FillNameTbl(28,  4,  1, 22, 0x08); /* E[ */

	// wiݒ
	FillAttribute(BG1_ATTR_HADR, BG1_ATTR_LADR, 0, 64);

	// }bv̏
	FillMemory(gamemap, 0, sizeof(gamemap));

	// }bv̓ǂݎ
	{
		unsigned char x, y;
		unsigned char c = 0;
		unsigned char e = 2;

		map = (unsigned char *)maps[scene];

		for (y = 0; y < MAP_FIELD_H; ++y) {
			for (x = 0; x < MAP_FIELD_W; ++x, ++c) {
				unsigned char m = map_get_symbol(c);
				unsigned char id;
				Chara* p;

				// }bvALN^̎擾
				id = GET_CHAR_ID(m);

				if (game.level > 0 && !(game.status & GAME_STATUS_PLAYDEMO)) {
					// ʗp̋ݒ
					switch (id) {
					case CHR_SLIME:
						id = CHR_RED_SLIME;
						break;
					case CHR_WIZARD:
						id = CHR_SORCERER;
						break;
					}
				}

				switch (id) {
				case CHR_BLUE_PENGUIN:
				case CHR_RED_PENGUIN:
					gamemap[y][x] = m;
					p = &chara[id];
					p->id = id;
					break;

				case CHR_SLIME:
				case CHR_WIZARD:
				case CHR_RED_SLIME:
				case CHR_SORCERER:
					if (e < CHARA_MAX) {
						gamemap[y][x] = GET_CHIP_ID(m)|MAP_CHAR_NO(e);
						p = &chara[e];
						p->id = e++;
						break;
					}

				default:
					gamemap[y][x] = GET_CHIP_ID(m);
					continue;
				}

				// LN^̏ʒuݒ
				p->chr = id;
				p->x = x << 4;
				p->y = y << 4;
			}
		}
	}

	// }bv񂩂wiݒ
	{
		unsigned char nam[2][MAP_FIELD_W*2];
		unsigned char x, y;

		for (y = 0; y < MAP_FIELD_H; ++y) {
			for (x = 0; x < MAP_FIELD_W; ++x) {
				unsigned char m = gamemap[y][x];
				const unsigned char *mc = mapchips[GET_CHIP_ID(m)];
				unsigned char dx = x << 1;

				nam[0][dx + 0] = mc[0];
				nam[0][dx + 1] = mc[1];
				nam[1][dx + 0] = mc[2];
				nam[1][dx + 1] = mc[3];
			}

			SetNameTbl(nam[0], (BG_NAMTBL_W-MAP_FIELD_W*2)/2, (BG_NAMTBL_H-MAP_FIELD_H*2)/2+y*2  , MAP_FIELD_W*2, 1);
			SetNameTbl(nam[1], (BG_NAMTBL_W-MAP_FIELD_W*2)/2, (BG_NAMTBL_H-MAP_FIELD_H*2)/2+y*2+1, MAP_FIELD_W*2, 1);
		}
	}

	// }bv񂩂瑮ݒ
	{
		unsigned char x, y;

		FillMemory(attrtbl, 0, sizeof(attrtbl));

		for (y = 0; y < MAP_FIELD_H; ++y) {
			unsigned char ay = y / 2 + (BG_NAMTBL_H-MAP_FIELD_H*2)/8;

			for (x = 0; x < MAP_FIELD_W; ++x) {
				unsigned char ax = x / 2 + (BG_NAMTBL_W-MAP_FIELD_W*2)/8;
				unsigned char m = GET_CHIP_ID(gamemap[y][x]);

				attrtbl[ay][ax] |= attrbg[m] << (((x & 1)? 2: 0) + ((y & 1)? 4: 0));
			}
		}

		for (y = 0; y < BG_ATTR_H; ++y) {
			unsigned char ladr = BG1_ATTR_LADR + y * BG_ATTR_W;
			SetAttribute(BG1_ATTR_HADR, ladr, attrtbl[y], sizeof(attrtbl[0]));
		}
	}
}

// wW̃}bvXVABGƑ̏s
void map_set(unsigned char x, unsigned char y, unsigned char mcp) {
	unsigned char mx;
	unsigned char my;
	const unsigned char* mc;
	unsigned int pos = screen_adr;
	unsigned char shift;

	gamemap[y][x] = mcp;

	mx = (x << 1) + (BG_NAMTBL_W-MAP_NAMTBL_W)/2;
	my = (y << 1) + (BG_NAMTBL_H-MAP_NAMTBL_H)/2;
	mcp = GET_CHIP_ID(mcp);
	mc = mapchips[mcp];
	SetCMD_2x2(mx, my, mc);

	mx >>= 2;
	my >>= 2;
	shift = ((x & 1)? 2: 0) + ((y & 1)? 4: 0);
	mcp = (attrbg[mcp] << shift) | (attrtbl[my][mx] & ~(3 << shift));
	attrtbl[my][mx] = mcp;
	SetAttrCMD_1x1(my, mx, mcp);
}

// QɕĎwW̃}bvړABG̏s
unsigned char map_move(unsigned char x, unsigned char y, unsigned char dir) {
	unsigned char mx;
	unsigned char my;
	const unsigned char* mc;
	unsigned int pos = screen_adr;
	unsigned char mcp;

	mx = (x << 1) + (BG_NAMTBL_W-MAP_NAMTBL_W)/2;
	my = (y << 1) + (BG_NAMTBL_H-MAP_NAMTBL_H)/2;
	mcp = gamemap[y][x];
	mc = mapchips[GET_CHIP_ID(mcp)];

	if (mcp & MCP_FLAG_MOVE) {
		// Qڂ̌Ăяo
		gamemap[y][x] = REMOVE_CHIP(mcp);

		switch (dir) {
		default:
		case 0:
			SetCMD_2x2_MoveUp(mx, my - 1, mc);
			break;
		case 1:
			SetCMD_2x2_MoveRight(mx + 1, my, mc);
			break;
		case 2:
			SetCMD_2x2_MoveDown(mx, my + 1, mc);
			break;
		case 3:
			SetCMD_2x2_MoveLeft(mx - 1, my, mc);
			break;
		}

		return 0;

	} else {
		// ̌Ăяo
		unsigned char shift;
		unsigned char i;

		gamemap[y][x] = mcp | MCP_FLAG_MOVE;

		switch (dir) {
		default:
		case 0:
			SetCMD_2x2_MoveUp(mx, my, mc);
			--y, my -= 2;
			break;
		case 1:
			SetCMD_2x2_MoveRight(mx, my, mc);
			++x, mx += 2;
			break;
		case 2:
			SetCMD_2x2_MoveDown(mx, my, mc);
			++y, my += 2;
			break;
		case 3:
			SetCMD_2x2_MoveLeft(mx, my, mc);
			--x, mx -= 2;
			break;
		}

		mx >>= 2;
		my >>= 2;
		shift = ((x & 1)? 2: 0) + ((y & 1)? 4: 0);

		mcp = REMOVE_CHAR(mcp) | REMOVE_CHIP(gamemap[y][x]);
		gamemap[y][x] = mcp;

		i = GET_CHIP_ID(mcp);
		i = (attrbg[i] << shift) | (attrtbl[my][mx] & ~(3 << shift));
		attrtbl[my][mx] = i;
		SetAttrCMD_1x1(my, mx, i);

		return 1;
	}
}

// V{`
#define _   0	// MCP_FIELD
#define O   1	// MCP_BALL
#define G   2	// MCP_GOAL
#define C   3	// MCP_ICECUBE
#define B   4	// MCP_BLOCK
#define F   5	// MCP_FBLOCK
#define W   6	// MCP_WALL
#define P1  7	// MAP_SYNBOL(CHR_BLUE_PENGUIN, MCP_FIELD)
#define P2  8	// MAP_SYNBOL(CHR_RED_PENGUIN, MCP_FIELD)
#define SL  9	// MAP_SYNBOL(CHR_SLIME, MCP_FIELD)
#define WZ  10	// MAP_SYNBOL(CHR_WIZARD, MCP_FIELD)
#define RS  11	// MAP_SYNBOL(CHR_RED_SLIME, MCP_FIELD)
#define SR  12	// MAP_SYNBOL(CHR_SORCERER, MCP_FIELD)

#define M(_h,_l) (((_h)<<4)|(_l))

const unsigned char symboltbl[] = {
/*  _ */	MCP_FIELD,
/*  O */	MCP_BALL,
/*  G */	MCP_GOAL,
/*  C */	MCP_ICECUBE,
/*  B */	MCP_BLOCK,
/*  F */	MCP_FBLOCK,
/*  W */	MCP_WALL,
/* P1 */	MAP_SYNBOL(CHR_BLUE_PENGUIN, MCP_FIELD),
/* P2 */	MAP_SYNBOL(CHR_RED_PENGUIN, MCP_FIELD),
/* SL */	MAP_SYNBOL(CHR_SLIME, MCP_FIELD),
/* WZ */	MAP_SYNBOL(CHR_WIZARD, MCP_FIELD),
/* RS */	MAP_SYNBOL(CHR_RED_SLIME, MCP_FIELD),
/* SR */	MAP_SYNBOL(CHR_SORCERER, MCP_FIELD),
};

unsigned char __fastcall__ map_get_symbol(unsigned char c) {
	unsigned char s = map[c>>1];

	if (!(c & 1)) {
		s >>= 4;
	}

	s &= 0x0f;

	return symboltbl[s];
}

// }bvf[^
const unsigned char map00[] = {
	M(P1, _),M( _, _),M( _, _),M( _, _),M( _, _),M( _, _), // P1, _, _, _, _, _, _, _, _, _, _, _,
	M( _, _),M( _, _),M( _, _),M( _, _),M( _, _),M( _, _), //  _, _, _, _, _, _, _, _, _, _, _, _,
	M( _, _),M( _, _),M( _, _),M( _, _),M( _, F),M( _, _), //  _, _, _, _, _, _, _, _, _, F, _, _,
	M( _, _),M( _, _),M( W, _),M( _, _),M( F, G),M( F, _), //  _, _, _, _, W, _, _, _, F, G, F, _,
	M( _, _),M( _,SL),M( _, W),M( _, _),M( _, F),M( _, _), //  _, _, _,SL, _, W, _, _, _, F, _, _,
	M( _, _),M( O, _),M( _, _),M( W, _),M( _, _),M( _, _), //  _, _, O, _, _, _, W, _, _, _, _, _,
	M( _, _),M( _, _),M( _, _),M( _, B),M( _, _),M( _, _), //  _, _, _, _, _, _, _, B, _, _, _, _,
	M( _, _),M( _, _),M( _, _),M( _, _),M( B, _),M( _, _), //  _, _, _, _, _, _, _, _, B, _, _, _,
	M( _, _),M( _, _),M( _, _),M( _, _),M( _, B),M( _, _), //  _, _, _, _, _, _, _, _, _, B, _, _,
	M( _, _),M( _, _),M( _, _),M( _, _),M( _, _),M( _, _), //  _, _, _, _, _, _, _, _, _, _, _, _,
	M( _, _),M( _, _),M( _, _),M( _, _),M( _, _),M( _,P2), //  _, _, _, _, _, _, _, _, _, _, _,P2,
};

const unsigned char map01[] = {
	M(P2, _),M( _, _),M( _, _),M( _, _),M( _, _),M( _, _), // P2, _, _, _, _, _, _, _, _, _, _, _,
	M( _, _),M( _, _),M( W, _),M( _, _),M( _, _),M( _, _), //  _, _, _, _, W, _, _, _, _, _, _, _,
	M( _, _),M( _, _),M( W, _),M( _, _),M( _, _),M( _, _), //  _, _, _, _, W, _, _, _, _, _, _, _,
	M( _, _),M( C, C),M( O, C),M( C, _),M( _, _),M( _, _), //  _, _, C, C, O, C, C, _, _, _, _, _,
	M( _, _),M( _, _),M( W, _),M( _, _),M( _, _),M( _, _), //  _, _, _, _, W, _, _, _, _, _, _, _,
	M( _, _),M( _, _),M( W, _),M( F, F),M( _, _),M( _, _), //  _, _, _, _, W, _, F, F, _, _, _, _,
	M( _, _),M( _, _),M( _,WZ),M( _, _),M( F, _),M( _, _), //  _, _, _, _, _,WZ, _, _, F, _, _, _,
	M( _, _),M( _, _),M( _, _),M( _, _),M( F, _),M( _, _), //  _, _, _, _, _, _, _, _, F, _, _, _,
	M( _, _),M( _, _),M( _, _),M( _, _),M( F, _),M( _, _), //  _, _, _, _, _, _, _, _, F, _, _, _,
	M( _, _),M( _, _),M( _, G),M( F, F),M( _, _),M( _, _), //  _, _, _, _, _, G, F, F, _, _, _, _,
	M( _, _),M( _, _),M( _, _),M( _, _),M( _, _),M( _,P1), //  _, _, _, _, _, _, _, _, _, _, _,P1,
};

const unsigned char map02[] = {
	M(P1, _),M( _, _),M( _, _),M( _, _),M( _, _),M( _, _), // P1, _, _, _, _, _, _, _, _, _, _, _,
	M( _, _),M( _, _),M( _, _),M( C, _),M( _, _),M(SL, _), //  _, _, _, _, _, _, C, _, _, _,SL, _,
	M( _, C),M( _, _),M( _, _),M( C, _),M( _,SL),M( O,SL), //  _, C, _, _, _, _, C, _, _,SL, O,SL,
	M( _, C),M( _, C),M( C, C),M( C, C),M( _, _),M(SL, _), //  _, C, _, C, C, C, C, C, _, _,SL, _,
	M( _, C),M( _, _),M( _, _),M( C, _),M( _, _),M( _, _), //  _, C, _, _, _, _, C, _, _, _, _, _,
	M( _, C),M( _, _),M( _, _),M( C, _),M( _, _),M( _, _), //  _, C, _, _, _, _, C, _, _, _, _, _,
	M( _, _),M( C, _),M( _, C),M( C, C),M( C, _),M( _, _), //  _, _, C, _, _, C, C, C, C, _, _, _,
	M( _, _),M( C, _),M( C, _),M( C, _),M( _, _),M( _, _), //  _, _, C, _, C, _, C, _, _, _, _, _,
	M( _, _),M( C, _),M( C, _),M( C, _),M( _, _),M( _, _), //  _, _, C, _, C, _, C, _, _, _, _, _,
	M( _, _),M( G, _),M( _, C),M( _, _),M( _, _),M( _, _), //  _, _, G, _, _, C, _, _, _, _, _, _,
	M( _, _),M( _, _),M( _, _),M( _, _),M( _, _),M( _,P2), //  _, _, _, _, _, _, _, _, _, _, _,P2,
};

const unsigned char map03[] = {
	M(P1, _),M( _, _),M( _, _),M( _, _),M( _, _),M( _, _), // P1, _, _, _, _, _, _, _, _, _, _, _,
	M( _, _),M( _, _),M( B, _),M( _, _),M( _, _),M( _, _), //  _, _, _, _, B, _, _, _, _, _, _, _,
	M( _, _),M( _, _),M( B, _),M( _, _),M( _, _),M( _, _), //  _, _, _, _, B, _, _, _, _, _, _, _,
	M( _, _),M( F, F),M( F, F),M( _,SL),M( _, _),M( _, _), //  _, _, F, F, F, F, _,SL, _, _, _, _,
	M( _, _),M( _, O),M( _, _),M( _, _),M(SL, _),M( _, _), //  _, _, _, O, _, _, _, _,SL, _, _, _,
	M( _, _),M( _, B),M( _, _),M( C, _),M( _, _),M( _, _), //  _, _, _, B, _, _, C, _, _, _, _, _,
	M( _, _),M( B, _),M( _, _),M( C, _),M( _, _),M( _, _), //  _, _, B, _, _, _, C, _, _, _, _, _,
	M( _, _),M(WZ, _),M( _, C),M( C, C),M( _, _),M( _, _), //  _, _,WZ, _, _, C, C, C, _, _, _, _,
	M( _, _),M( _, _),M( C, G),M( C, _),M( _, _),M( _, _), //  _, _, _, _, C, G, C, _, _, _, _, _,
	M( _, _),M( _, _),M( _, C),M( _, _),M( _, _),M( _, _), //  _, _, _, _, _, C, _, _, _, _, _, _,
	M( _, _),M( _, _),M( _, _),M( _, _),M( _, _),M( _,P2), //  _, _, _, _, _, _, _, _, _, _, _,P2,
};

const unsigned char map04[] = {
	M(P1, _),M( _, _),M( _, _),M( _, _),M( _, _),M( _, _), // P1, _, _, _, _, _, _, _, _, _, _, _,
	M( _, _),M( C, C),M( C,SL),M( C, C),M( C, _),M( _, _), //  _, _, C, C, C,SL, C, C, C, _, _, _,
	M( _, _),M( _, _),M( _, W),M( _, _),M( _, _),M( _, _), //  _, _, _, _, _, W, _, _, _, _, _, _,
	M( _, _),M( _, _),M( _, W),M( _, _),M( _, _),M( _, _), //  _, _, _, _, _, W, _, _, _, _, _, _,
	M( _, _),M( G, C),M( C, _),M( C, C),M(SL, _),M( _, _), //  _, _, G, C, C, _, C, C,SL, _, _, _,
	M( _, _),M( _, _),M( _,WZ),M( _, _),M( _, _),M( _, _), //  _, _, _, _, _,WZ, _, _, _, _, _, _,
	M( _, _),M( _, _),M( W, _),M( F, _),M( _, _),M( _, _), //  _, _, _, _, W, _, F, _, _, _, _, _,
	M( _, _),M( _, W),M( _, _),M( _, F),M( _, _),M( _, _), //  _, _, _, W, _, _, _, F, _, _, _, _,
	M( _, _),M( _, W),M( _, _),M( _, F),M( _, _),M( _, _), //  _, _, _, W, _, _, _, F, _, _, _, _,
	M( _, _),M( W, _),M( _, _),M( _, _),M( F, _),M( _, _), //  _, _, W, _, _, _, _, _, F, _, _, _,
	M( _, W),M( _, _),M( _, _),M( _, _),M( _, O),M( _,P2), //  _, W, _, _, _, _, _, _, _, O, _,P2,
};

const unsigned char map05[] = {
	M(P1, _),M( _, _),M( _, _),M( _, _),M( _, _),M( _, _), // P1, _, _, _, _, _, _, _, _, _, _, _,
	M( _, _),M( _, _),M( _, _),M( _, _),M( _, _),M( _, _), //  _, _, _, _, _, _, _, _, _, _, _, _,
	M( _, _),M( _, _),M( _, _),M( W, _),M( _,SL),M( _, _), //  _, _, _, _, _, _, W, _, _,SL, _, _,
	M( _, _),M( _, _),M( _, _),M( _, _),M( _, _),M( _, _), //  _, _, _, _, _, _, _, _, _, _, _, _,
	M( _, _),M( _, _),M( _, _),M( _, _),M( _, _),M( _, _), //  _, _, _, _, _, _, _, _, _, _, _, _,
	M( _, _),M( O, B),M( F, C),M( C, F),M( B, G),M( _, _), //  _, _, O, B, F, C, C, F, B, G, _, _,
	M( _, _),M( _, _),M( _, _),M( _, _),M( _, _),M( _, _), //  _, _, _, _, _, _, _, _, _, _, _, _,
	M( _, _),M( _, _),M( _, _),M( _, _),M( _, _),M( _, _), //  _, _, _, _, _, _, _, _, _, _, _, _,
	M( _, _),M(SL, _),M( _, C),M( _, _),M( _, _),M( _, _), //  _, _,SL, _, _, C, _, _, _, _, _, _,
	M( _, _),M( _, _),M( _, _),M( _, _),M( _, _),M( _, _), //  _, _, _, _, _, _, _, _, _, _, _, _,
	M( _, _),M( _, _),M( _, _),M( _, _),M( _, _),M( _,P2), //  _, _, _, _, _, _, _, _, _, _, _,P2,
};

const unsigned char map06[] = {
	M(P1, _),M( _, _),M( _, _),M( _, _),M( _, _),M( _, _), // P1, _, _, _, _, _, _, _, _, _, _, _,
	M( _, _),M( F, _),M( _, _),M( _, _),M( _, B),M( _, _), //  _, _, F, _, _, _, _, _, _, B, _, _,
	M( _, F),M( O, F),M( _, _),M( _, _),M( _,SL),M( W, _), //  _, F, O, F, _, _, _, _, _,SL, W, _,
	M( _, _),M( F, _),M( _, _),M( _, _),M( _, _),M( _, _), //  _, _, F, _, _, _, _, _, _, _, _, _,
	M( _, _),M( _, _),M( _, _),M( _, _),M( _, _),M( _, _), //  _, _, _, _, _, _, _, _, _, _, _, _,
	M( _, _),M( _, _),M( _, _),M( _, _),M( _, _),M( _, _), //  _, _, _, _, _, _, _, _, _, _, _, _,
	M( _, _),M( _, _),M( _, _),M( _, _),M( _, _),M( _, _), //  _, _, _, _, _, _, _, _, _, _, _, _,
	M( _, _),M( _, _),M( _, _),M( _, _),M( _, B),M( _, _), //  _, _, _, _, _, _, _, _, _, B, _, _,
	M( _, F),M(SL, _),M( _, _),M( _, _),M( B, G),M( B, _), //  _, F,SL, _, _, _, _, _, B, G, B, _,
	M( _, _),M( W, _),M( _, _),M( _, _),M( _, B),M( _, _), //  _, _, W, _, _, _, _, _, _, B, _, _,
	M( _, _),M( _, _),M( _, _),M( _, _),M( _, _),M( _,P2), //  _, _, _, _, _, _, _, _, _, _, _,P2,
};

const unsigned char map07[] = {
	M(P1, C),M( _, _),M( _, C),M( _, _),M( _, C),M( _, _), // P1, C, _, _, _, C, _, _, _, C, _, _,
	M( _, C),M( _,SL),M( _, C),M( _,SL),M( _, C),M( _, C), //  _, C, _,SL, _, C, _,SL, _, C, _, C,
	M( O, C),M( _, C),M( _, C),M( _, C),M( _, C),M( _, C), //  O, C, _, C, _, C, _, C, _, C, _, C,
	M( _, C),M( _, C),M( _, C),M( _, C),M( _, C),M( _, C), //  _, C, _, C, _, C, _, C, _, C, _, C,
	M( _, C),M( _, C),M( _, C),M( _, C),M( _, C),M( _, C), //  _, C, _, C, _, C, _, C, _, C, _, C,
	M( _, C),M( _, C),M( _, C),M( _, C),M( _, C),M( _, C), //  _, C, _, C, _, C, _, C, _, C, _, C,
	M( _, C),M( _, C),M( _, C),M( _, C),M( _, C),M( _, C), //  _, C, _, C, _, C, _, C, _, C, _, C,
	M( _, C),M( _, C),M( _, C),M( _, C),M( _, C),M( _, C), //  _, C, _, C, _, C, _, C, _, C, _, C,
	M( _, C),M( _, C),M( _, C),M( _, C),M( _, C),M( _, G), //  _, C, _, C, _, C, _, C, _, C, _, G,
	M( _, C),M( _, C),M( _,SL),M( _, C),M( _, C),M( _, _), //  _, C, _, C, _,SL, _, C, _, C, _, _,
	M( _, _),M( _, C),M( _, _),M( _, C),M( _, _),M( _,P2), //  _, _, _, C, _, _, _, C, _, _, _,P2,
};

const unsigned char map08[] = {
	M(P1, _),M( _, _),M( _, _),M( _, _),M( _, _),M( _, _), // P1, _, _, _, _, _, _, _, _, _, _, _,
	M( _, C),M( C, C),M( C, C),M( C, C),M( C, C),M( C, _), //  _, C, C, C, C, C, C, C, C, C, C, _,
	M( _, C),M( O, _),M( _, _),M( _, _),M( _,SL),M( C, _), //  _, C, O, _, _, _, _, _, _,SL, C, _,
	M( _, C),M( C, _),M( _, _),M( _, _),M( _, C),M( C, _), //  _, C, C, _, _, _, _, _, _, C, C, _,
	M( _, C),M( _, C),M( _, _),M( _, _),M( C, _),M( C, _), //  _, C, _, C, _, _, _, _, C, _, C, _,
	M( _, C),M( _, _),M( C, B),M( B, C),M( _, _),M( C, _), //  _, C, _, _, C, B, B, C, _, _, C, _,
	M( _, C),M( _, _),M( _, B),M( B, _),M( _, _),M( C, _), //  _, C, _, _, _, B, B, _, _, _, C, _,
	M( _, C),M( _, _),M( _, _),M( _, _),M( _, _),M( C, _), //  _, C, _, _, _, _, _, _, _, _, C, _,
	M( _, C),M(SL, _),M( _, _),M( _, _),M( _, G),M( C, _), //  _, C,SL, _, _, _, _, _, _, G, C, _,
	M( _, C),M( C, C),M( C, C),M( C, C),M( C, C),M( C, _), //  _, C, C, C, C, C, C, C, C, C, C, _,
	M( _, _),M( _, _),M( _, _),M( _, _),M( _, _),M( _,P2), //  _, _, _, _, _, _, _, _, _, _, _,P2,
};

const unsigned char map09[] = {
	M(P1, F),M( _, F),M( _, B),M( F, _),M( B, _),M( B, _), // P1, F, _, F, _, B, F, _, B, _, B, _,
	M( _, B),M( F, B),M( _, F),M( B, _),M( F, B),M( F, _), //  _, B, F, B, _, F, B, _, F, B, F, _,
	M( _, F),M( O, F),M( _, B),M( F, _),M( B, _),M( B, _), //  _, F, O, F, _, B, F, _, B, _, B, _,
	M( _, B),M( F, B),M( _, F),M( B, _),M( F, B),M( F, _), //  _, B, F, B, _, F, B, _, F, B, F, _,
	M( _, F),M( _, F),M( _, B),M( F, _),M( B, _),M( B, _), //  _, F, _, F, _, B, F, _, B, _, B, _,
	M( _, B),M( F, B),M( _,SL),M(SL, _),M( F, B),M( F, _), //  _, B, F, B, _,SL,SL, _, F, B, F, _,
	M( _, F),M( _, F),M( _, B),M( F, _),M( B, _),M( B, _), //  _, F, _, F, _, B, F, _, B, _, B, _,
	M( _, B),M( F, B),M( _, F),M( B, _),M( F, B),M( F, _), //  _, B, F, B, _, F, B, _, F, B, F, _,
	M( _, F),M( _, F),M( _, B),M( F, _),M( B, G),M( B, _), //  _, F, _, F, _, B, F, _, B, G, B, _,
	M( _, B),M( F, B),M( _, F),M( B, _),M( F, B),M( F, _), //  _, B, F, B, _, F, B, _, F, B, F, _,
	M( _, F),M( _, F),M( _, B),M( F, _),M( B, _),M( B,P2), //  _, F, _, F, _, B, F, _, B, _, B,P2,
};

const unsigned char map10[] = {
	M(P1, _),M( _, _),M( _, _),M( _, _),M( _, _),M( _, _), // P1, _, _, _, _, _, _, _, _, _, _, _,
	M( _, C),M( C, C),M( C, C),M( C, C),M( C, C),M( C, _), //  _, C, C, C, C, C, C, C, C, C, C, _,
	M( _, C),M( O, _),M( _, _),M( _, _),M( _,SL),M( C, _), //  _, C, O, _, _, _, _, _, _,SL, C, _,
	M( _, C),M( _, _),M( _, _),M( _, _),M( _, _),M( C, _), //  _, C, _, _, _, _, _, _, _, _, C, _,
	M( _, C),M( _, _),M( W, W),M( W, W),M( _, _),M( C, _), //  _, C, _, _, W, W, W, W, _, _, C, _,
	M( _, C),M( _, _),M( _,SL),M( G, _),M( _, _),M( C, _), //  _, C, _, _, _,SL, G, _, _, _, C, _,
	M( _, C),M( _, _),M( W, W),M( W, W),M( _, _),M( C, _), //  _, C, _, _, W, W, W, W, _, _, C, _,
	M( _, C),M( _, _),M( _, _),M( _, _),M( _, _),M( C, _), //  _, C, _, _, _, _, _, _, _, _, C, _,
	M( _, C),M(SL, _),M( _, _),M( _, _),M( _, _),M( C, _), //  _, C,SL, _, _, _, _, _, _, _, C, _,
	M( _, C),M( C, C),M( C, C),M( C, C),M( C, C),M( C, _), //  _, C, C, C, C, C, C, C, C, C, C, _,
	M( _, _),M( _, _),M( _, _),M( _, _),M( _, _),M( _,P2), //  _, _, _, _, _, _, _, _, _, _, _,P2,
};

const unsigned char map11[] = {
	M(P1, _),M( C, _),M( _, C),M( _, _),M( C, _),M( _,RS), // P1, _, C, _, _, C, _, _, C, _, _,SL,
	M( _, C),M( _, _),M( C, _),M( _, C),M( _, _),M( C, _), //  _, C, _, _, C, _, _, C, _, _, C, _,
	M( C, _),M( G, C),M( _, _),M( C, _),M( _, C),M( _, _), //  C, _, G, C, _, _, C, _, _, C, _, _,
	M( _, _),M( C, _),M( _, C),M( _, _),M( C, _),M( _, C), //  _, _, C,SL, _, C, _, _, C, _, _, C,
	M( _, C),M( _, _),M( C, _),M( _, C),M( _, _),M( C, _), //  _, C, _, _, C, _, _, C, _, _, C, _,
	M( C, _),M( _, C),M( _, _),M( C, _),M( _, C),M( _, _), //  C, _, _, C, _, _, C, _, _, C, _, _,
	M( _, _),M( C, _),M( _, C),M( _, _),M( C, _),M( _, C), //  _, _, C, _, _, C, _, _, C, _, _, C,
	M( _, C),M( _, _),M( C, _),M( _, C),M( _, _),M( C, _), //  _, C, _, _, C, _, _, C,SL, _, C, _,
	M( C, _),M( _, C),M( _, _),M( C, _),M( _, O),M( _, _), //  C, _, _, C, _, _, C, _, _, O, _, _,
	M( _, _),M( C, _),M( _, C),M( _, _),M( C, _),M( _, C), //  _, _, C, _, _, C, _, _, C, _, _, C,
	M(RS, C),M( _, _),M( C, _),M( _, C),M( _, _),M( C,P2), // SL, C, _, _, C, _, _, C, _, _, C,P2,
};

const unsigned char map12[] = {
	M(P1, _),M( C, C),M( C, C),M( C, C),M( F, F),M( _, _), // P1, _, C, C, C, C, C, C, F, F, _, _,
	M( _,SL),M( _,SL),M( F, F),M( _, _),M( F, C),M( C, C), //  _,SL, _,SL, F, F, _, _, F, C, C, C,
	M( _, _),M( O, C),M( C, C),M( C, C),M( C, C),M( _, _), //  _, _, O, C, C, C, C, C, C, C, _, _,
	M( _,SL),M( _,SL),M( F, F),M( _, _),M( F, F),M( _, _), //  _,SL, _,SL, F, F, _, _, F, F, _, _,
	M( _, _),M( _, _),M( F, F),M( _, C),M( C, F),M( C, C), //  _, _, _, _, F, F, _, C, C, F, C, C,
	M( _, _),M( _, _),M( F, F),M( _, _),M( F, F),M( _, _), //  _, _, _, _, F, F, _, _, F, F, _, _,
	M( _, _),M( _, _),M( F, F),M( _, _),M( F, F),M( _, _), //  _, _, _, _, F, F, _, _, F, F, _, _,
	M( _, _),M( _, _),M( F, F),M( _, _),M( F, F),M( _, _), //  _, _, _, _, F, F, _, _, F, F, _, _,
	M( _, _),M( _, _),M( F, F),M( _, _),M( F, G),M( _, _), //  _, _, _, _, F, F, _, _, F, G, _, _,
	M( B, B),M( B, B),M( F, F),M( B, B),M( F, F),M( B, B), //  B, B, B, B, F, F, B, B, F, F, B, B,
	M( B, B),M( B, B),M( F, F),M( B, B),M( F, F),M( B,P2), //  B, B, B, B, F, F, B, B, F, F, B,P2,
};

const unsigned char map13[] = {
	M(P1, _),M( _, _),M( _, _),M( _, _),M( _, _),M( _,WZ), // P1, _, _, _, _, _, _, _, _, _, _,WZ,
	M( _, _),M( _, _),M( _, B),M( C, _),M( _, _),M( _, _), //  _, _, _, _, _, B, C, _, _, _, _, _,
	M( _, _),M( _, _),M( B, B),M( C, C),M( _, _),M( _, _), //  _, _, _, _, B, B, C, C, _, _, _, _,
	M( _, _),M( _, B),M( B, B),M( C, C),M( C, _),M( _, _), //  _, _, _, B, B, B, C, C, C, _, _, _,
	M( _, _),M( B, B),M( O, B),M( C, C),M( C, C),M( _, _), //  _, _, B, B, O, B, C, C, C, C, _, _,
	M( _, B),M( B, B),M( B, B),M( F, F),M( F, F),M( F, _), //  _, B, B, B, B, B, F, F, F, F, F, _,
	M( _, _),M( C, C),M( C, C),M( F, G),M( F, F),M( _, _), //  _, _, C, C, C, C, F, G, F, F, _, _,
	M( _, _),M( _, C),M( C, C),M( F, F),M( F, _),M( _, _), //  _, _, _, C, C, C, F, F, F, _, _, _,
	M( _, _),M( _, _),M( C, C),M( F, F),M( _, _),M( _, _), //  _, _, _, _, C, C, F, F, _, _, _, _,
	M( _, _),M( _, _),M( _, C),M( F, _),M( _, _),M( _, _), //  _, _, _, _, _, C, F, _, _, _, _, _,
	M(WZ, _),M( _, _),M( _, _),M( _, _),M( _, _),M( _,P2), // WZ, _, _, _, _, _, _, _, _, _, _,P2,
};

const unsigned char map14[] = {
	M(P1, _),M( _, _),M( _, _),M( _, _),M( _, _),M( _, _), // P1, _, _, _, _, _, _, _, _, _, _, _,
	M( _, _),M( _, _),M( _, _),M( _, _),M( _, _),M( _, _), //  _, _, _, _, _, _, _, _, _, _, _, _,
	M( _, _),M( C, C),M( _, _),M( _, C),M( C, _),M( _, _), //  _, _, C, C, _, _, _, C, C, _, _, _,
	M( _, C),M( C, C),M( C, _),M( C, C),M( C, C),M( _, _), //  _, C, C, C, C, _, C, C, C, C, _, _,
	M( _, C),M( O, C),M( C,WZ),M( C, C),M( C, C),M( _, _), //  _, C, O, C, C,WZ, C, C, C, C, _, _,
	M( _, C),M( C, C),M( C, C),M( C, C),M( C, C),M( _, _), //  _, C, C, C, C, C, C, C, C, C, _, _,
	M( _, _),M( C, C),M( C, C),M( C, C),M( C, _),M( _, _), //  _, _, C, C, C, C, C, C, C, _, _, _,
	M( _, _),M( _, C),M( C, C),M( C, C),M( _,SL),M( _, _), //  _, _, _, C, C, C, C, C, _,SL, _, _,
	M( _, _),M( _, _),M( C,WZ),M( C, _),M(SL, G),M( _, _), //  _, _, _, _, C,WZ, C, _,SL, G, _, _,
	M( _, _),M( _, _),M( _, C),M( _, _),M( _, _),M( _, _), //  _, _, _, _, _, C, _, _, _, _, _, _,
	M( _, _),M( _, _),M( _, _),M( _, _),M( _, _),M( _,P2), //  _, _, _, _, _, _, _, _, _, _, _,P2,
};

const unsigned char map15[] = {
	M(P1, _),M( _, _),M( _, C),M( C, _),M( _, _),M( _, _), // P1, _, _, _, _, C, C, _, _, _, _, _,
	M( _, _),M( _, _),M( C, C),M( C, C),M( _, _),M( _, _), //  _, _, _, _, C, C, C, C, _, _, _, _,
	M( _, _),M( _, _),M( C, C),M( C, C),M( _, _),M( _, _), //  _, _, _, _, C, C, C, C, _, _, _, _,
	M( _, _),M( _, _),M( _,SL),M(SL, _),M( _, _),M( _, _), //  _, _, _, _, _,SL,SL, _, _, _, _, _,
	M( _, _),M( C, C),M( _, F),M( F, _),M( C, C),M( _, _), //  _, _, C, C, _, F, F, _, C, C, _, _,
	M( _, C),M( C, C),M( C, F),M( F, C),M( C, C),M( C, _), //  _, C, C, C, C, F, F, C, C, C, C, _,
	M( _, C),M( O, C),M( C, F),M( F, C),M( C, G),M( C, _), //  _, C, O, C, C, F, F, C, C, G, C, _,
	M( _, _),M( C, C),M( _,WZ),M(WZ, _),M( C, C),M( _, _), //  _, _, C, C, _,WZ,WZ, _, C, C, _, _,
	M( _, _),M( _, _),M( _, F),M( F, _),M( _, _),M( _, _), //  _, _, _, _, _, F, F, _, _, _, _, _,
	M( _, _),M( _, _),M( F, F),M( F, F),M( _, _),M( _, _), //  _, _, _, _, F, F, F, F, _, _, _, _,
	M( _, _),M( _, _),M( F, F),M( F, F),M( _, _),M( _,P2), //  _, _, _, _, F, F, F, F, _, _, _,P2,
};

const unsigned char map16[] = {
	M(P1, _),M( _, _),M( _, W),M( C, _),M( _, _),M( _, _), // P1, _, _, _, _, W, C, _, _, _, _, _,
	M( _, _),M( _, _),M( _, W),M( C, _),M( _, _),M( _, _), //  _, _, _, _, _, W, C, _, _, _, _, _,
	M( _, O),M( _, _),M( W, C),M( C, C),M( _, _),M( _, _), //  _, O, _, _, W, C, C, C, _, _, _, _,
	M( _, _),M( _, W),M( C, C),M( C, C),M( W, _),M( _, _), //  _, _, _, W, C, C, C, C, W, _, _, _,
	M( _, _),M( W, C),M( C, C),M( C, C),M( C, C),M( _, _), //  _, _, W, C, C, C, C, C, C, C, _, _,
	M( _, W),M( C, C),M( C, C),M( C, C),M( G, C),M( C, _), //  _, W, C, C, C, C, C, C, G, C, C, _,
	M( _, C),M( C, C),M( C, C),M( C, C),M( C, C),M( C, _), //  _, C, C, C, C, C, C, C, C, C, C, _,
	M( _, _),M( C, C),M( _, W),M( C, _),M( C, C),M( _, _), //  _, _, C, C, _, W, C, _, C, C, _, _,
	M( _, _),M( _, _),M( _, W),M( C, _),M( _, _),M( _, _), //  _, _, _, _, _, W, C, _, _, _, _, _,
	M( _, _),M( _, _),M( W, C),M( C, C),M( _, _),M( _, _), //  _, _, _, _, W, C, C, C, _, _, _, _,
	M( _, _),M( _,WZ),M( C, C),M( C, C),M(WZ, _),M( _,P2), //  _, _, _,WZ, C, C, C, C,WZ, _, _,P2,
};

const unsigned char map17[] = {
	M(P1, B),M( B, B),M( B, B),M( B, B),M( B, B),M( B, F), // P1, B, B, B, B, B, B, B, B, B, B, F,
	M( B, B),M( B, B),M( B, B),M( B, B),M( B, B),M( F, F), //  B, B, B, B, B, B, B, B, B, B, F, F,
	M( B, B),M( O, B),M( B, B),M( B, B),M( B, F),M(WZ, F), //  B, B, O, B, B, B, B, B, B, F,WZ, F,
	M( B, B),M( B, B),M( B, B),M( B, B),M( F, F),M( F, F), //  B, B, B, B, B, B, B, B, F, F, F, F,
	M( B, B),M( B, B),M( B, B),M( B, F),M( F, F),M( F, F), //  B, B, B, B, B, B, B, F, F, F, F, F,
	M( B, B),M( B, B),M( B, B),M( F, F),M( F, F),M( F, F), //  B, B, B, B, B, B, F, F, F, F, F, F,
	M( B, B),M( B, B),M( B, F),M( F, F),M( F, F),M( F, F), //  B, B, B, B, B, F, F, F, F, F, F, F,
	M( B, B),M( B, B),M( F, F),M( F, F),M( F, F),M( F, F), //  B, B, B, B, F, F, F, F, F, F, F, F,
	M( B, B),M(WZ, F),M( F, F),M( F, F),M( F, G),M( F, F), //  B, B,WZ, F, F, F, F, F, F, G, F, F,
	M( B, B),M( F, F),M( F, F),M( F, F),M( F, F),M( F, F), //  B, B, F, F, F, F, F, F, F, F, F, F,
	M( B, F),M( F, F),M( F, F),M( F, F),M( F, F),M( F,P2), //  B, F, F, F, F, F, F, F, F, F, F,P2,
};

const unsigned char map18[] = {
	M(P1, _),M( _, _),M( _, _),M( _, _),M( _, _),M( _, _), // P1, _, _, _, _, _, _, _, _, _, _, _,
	M( _, C),M( C, C),M( C, C),M( C, C),M( C, C),M( W, _), //  _, C, C, C, C, C, C, C, C, C, W, _,
	M( _, C),M( O, _),M( _, _),M( _, _),M( _,WZ),M( F, _), //  _, C, O, _, _, _, _, _, _,WZ, F, _,
	M( _, C),M( C, C),M( C, C),M( C, C),M( C, C),M( W, _), //  _, C, C, C, C, C, C, C, C, C, W, _,
	M( _, W),M( W, W),M( W, W),M( W, W),M( W, W),M( W, _), //  _, W, W, W, W, W, W, W, W, W, W, _,
	M( _, _),M( _, _),M( _, _),M( _, _),M( _, _),M( _, _), //  _, _, _, _, _, _, _, _, _, _, _, _,
	M( _, W),M( W, W),M( W, W),M( W, W),M( W, W),M( W, _), //  _, W, W, W, W, W, W, W, W, W, W, _,
	M( _, W),M( C, C),M( C, C),M( C, C),M( C, C),M( C, _), //  _, W, C, C, C, C, C, C, C, C, C, _,
	M( _, B),M(SL, _),M( _, _),M( _, _),M( _, G),M( C, _), //  _, B,SL, _, _, _, _, _, _, G, C, _,
	M( _, W),M( C, C),M( C, C),M( C, C),M( C, C),M( C, _), //  _, W, C, C, C, C, C, C, C, C, C, _,
	M( _, _),M( _, _),M( _, _),M( _, _),M( _, _),M( _,P2), //  _, _, _, _, _, _, _, _, _, _, _,P2,
};

const unsigned char map19[] = {
	M(P2, C),M( _, _),M( C, _),M( _, W),M( _, _),M( _, _), // P2, C, _, _, C, _, _, W, _, _, _, _,
	M( _, C),M( C, C),M( _, _),M( W, _),M( _, _),M(SL, _), //  _, C, C, C, _, _, W, _, _, _,SL, _,
	M( _, C),M( O, C),M( _, _),M( W, _),M( _, _),M( _, _), //  _, C, O, C, _, _, W, _, _, _, _, _,
	M( _, _),M( C, _),M( _, C),M(SL, B),M( _, _),M( _, _), //  _, _, C, _, _, C,SL, B, _, _, _, _,
	M( _, _),M( _, F),M( _, F),M( B, _),M( B, _),M( _, _), //  _, _, _, F, _, F, B, _, B, _, _, _,
	M( _, _),M( _, F),M( _, F),M( B, _),M( B, _),M( _, _), //  _, _, _, F, _, F, B, _, B, _, _, _,
	M( _, _),M( _, F),M( _, F),M( B, _),M( B, _),M( _, _), //  _, _, _, F, _, F, B, _, B, _, _, _,
	M( _, _),M( _, _),M( F,SL),M( C, _),M( _, C),M( _, _), //  _, _, _, _, F,SL, C, _, _, C, _, _,
	M( _, _),M( _, _),M( _, W),M( _, _),M( C, G),M( C, _), //  _, _, _, _, _, W, _, _, C, G, C, _,
	M( _,SL),M( _, _),M( _, W),M( _, _),M( C, C),M( C, _), //  _,SL, _, _, _, W, _, _, C, C, C, _,
	M( _, _),M( _, _),M( W, _),M( _, C),M( _, _),M( C,P1), //  _, _, _, _, W, _, _, C, _, _, C,P1,
};

const unsigned char map20[] = {
	M(P1, W),M( _, _),M( _, _),M( _, _),M( _, _),M( B, _), // P1, W, _, _, _, _, _, _, _, _, B, _,
	M( _, _),M( W, _),M( _, _),M( _, _),M( _, B),M( _, _), //  _, _, W, _, _, _, _, _, _, B, _, _,
	M( _, _),M( O, W),M( _, _),M( _, _),M( B,SL),M( _, _), //  _, _, O, W, _, _, _, _, B,SL, _, _,
	M( _, _),M( W, _),M( _, C),M( C, _),M( _, B),M( _, _), //  _, _, W, _, _, C, C, _, _, B, _, _,
	M( _, W),M( _, _),M( C, _),M( _, C),M( _, _),M( B, _), //  _, W, _, _, C, _, _, C, _, _, B, _,
	M( _, _),M( _, C),M(WZ, _),M( _,WZ),M( C, _),M( _, _), //  _, _, _, C,WZ, _, _,WZ, C, _, _, _,
	M( _, F),M( _, _),M( C, _),M( _, C),M( _, _),M( W, _), //  _, F, _, _, C, _, _, C, _, _, W, _,
	M( _, _),M( F, _),M( _, C),M( C, _),M( _, W),M( _, _), //  _, _, F, _, _, C, C, _, _, W, _, _,
	M( _, _),M(SL, F),M( _, _),M( _, _),M( W, G),M( _, _), //  _, _,SL, F, _, _, _, _, W, G, _, _,
	M( _, _),M( F, _),M( _, _),M( _, _),M( _, W),M( _, _), //  _, _, F, _, _, _, _, _, _, W, _, _,
	M( _, F),M( _, _),M( _, _),M( _, _),M( _, _),M( W,P2), //  _, F, _, _, _, _, _, _, _, _, W,P2,
};

const unsigned char map21[] = {
	M(P1, _),M( _, _),M( _, _),M( _, _),M( _, _),M( _, _), // P1, _, _, _, _, _, _, _, _, _, _, _,
	M( W, C),M( W, C),M( W, C),M( W, C),M( W, C),M( W, _), //  W, C, W, C, W, C, W, C, W, C, W, _,
	M( _, _),M( _, _),M( _, _),M( _, _),M( _, _),M( _, _), //  _, _, _, _, _, _, _, _, _, _, _, _,
	M( W, F),M( W, F),M( W, F),M( W, F),M( W, F),M( W, _), //  W, F, W, F, W, F, W, F, W, F, W, _,
	M( _, _),M( _, _),M( _,WZ),M( _, _),M( _, _),M( _, _), //  _, _, _, _, _,WZ, _, _, _, _, _, _,
	M( W, C),M( W, C),M( W, C),M( W, C),M( W, C),M( W, _), //  W, C, W, C, W, C, W, C, W, C, W, _,
	M( O, _),M( _, _),M( _, G),M( _, _),M( _, _),M( _, _), //  O, _, _, _, _, G, _, _, _, _, _, _,
	M( W, B),M( W, B),M( W, B),M( W, B),M( W, B),M( W, _), //  W, B, W, B, W, B, W, B, W, B, W, _,
	M( _, _),M( _, _),M( _,WZ),M( _, _),M( _, _),M( _, _), //  _, _, _, _, _,WZ, _, _, _, _, _, _,
	M( W, C),M( W, C),M( W, C),M( W, C),M( W, C),M( W, _), //  W, C, W, C, W, C, W, C, W, C, W, _,
	M( _, _),M( _, _),M( _, _),M( _, _),M( _, _),M( _,P2), //  _, _, _, _, _, _, _, _, _, _, _,P2,
};

const unsigned char map22[] = {
	M(P1, _),M( B, _),M( _, F),M( _, _),M( C, _),M( _, _), // P1, _, B, _, _, F, _, _, C, _, _, _,
	M( _, _),M( B, _),M( _, F),M( _,SL),M( C, _),M( _, _), //  _, _, B, _, _, F, _,SL, C, _, _, _,
	M( _, _),M( B, _),M( _, F),M( _, _),M( C, _),M( _, _), //  _, _, B, _, _, F, _, _, C, _, _, _,
	M( _, _),M( B, _),M( _, F),M( _, _),M( C, _),M( _, _), //  _, _, B, _, _, F, _, _, C, _, _, _,
	M( _, _),M( B, _),M( F, F),M( _, C),M( C, _),M(WZ, C), //  _, _, B, _, F, F, _, C, C, _,WZ, C,
	M( O, _),M( B,SL),M( F, F),M( C, C),M( C, _),M( _, G), //  O, _, B,SL, F, F, C, C, C, _, _, G,
	M( _, _),M( B, _),M( F, F),M( _, C),M( C, _),M(WZ, C), //  _, _, B, _, F, F, _, C, C, _,WZ, C,
	M( _, _),M( B, _),M( _, F),M( _, _),M( C, _),M( _, _), //  _, _, B, _, _, F, _, _, C, _, _, _,
	M( _, _),M( B, _),M( _, F),M( _, _),M( C, _),M( _, _), //  _, _, B, _, _, F, _, _, C, _, _, _,
	M( _, _),M( B, _),M( _, F),M( _,SL),M( C, _),M( _, _), //  _, _, B, _, _, F, _,SL, C, _, _, _,
	M(P2, _),M( B, _),M( _, F),M( _, _),M( C, _),M( _, _), // P2, _, B, _, _, F, _, _, C, _, _, _,
};

const unsigned char map23[] = {
	M(P1, _),M( _, _),M( _, _),M( _, _),M( _, _),M( _, _), // P1, _, _, _, _, _, _, _, _, _, _, _,
	M( _, O),M( _, _),M( _, _),M( _, _),M( _, _),M(WZ, _), //  _, O, _, _, _, _, _, _, _, _,WZ, _,
	M( W, W),M( W, W),M( W, W),M( W, W),M( W, W),M( _, _), //  W, W, W, W, W, W, W, W, W, W, _, _,
	M( _, _),M( _, _),M( _, _),M( _, _),M( _, C),M( _, _), //  _, _, _, _, _, _, _, _, _, C, _, _,
	M( _, _),M( _, _),M( _, _),M( _, _),M( _, B),M( _, _), //  _, _, _, _, _, _, _, _, _, B, _, _,
	M( _, _),M( W, W),M( W, W),M( W, _),M( _, W),M( _, _), //  _, _, W, W, W, W, W, _, _, W, _, _,
	M( _, _),M( W, G),M( _, _),M( _, _),M( _, W),M( _, _), //  _, _, W, G, _, _, _, _, _, W, _, _,
	M( _, _),M( W, _),M( _, _),M( _, _),M( _, W),M( _, _), //  _, _, W, _, _, _, _, _, _, W, _, _,
	M( _, _),M( W, W),M( W, W),M( W, B),M( W, W),M( _, _), //  _, _, W, W, W, W, W, B, W, W, _, _,
	M( _,WZ),M( _, _),M( _, _),M( _, _),M( _, _),M( _, _), //  _,WZ, _, _, _, _, _, _, _, _, _, _,
	M( _, _),M( _, _),M( _, _),M( _, _),M( _, _),M( _,P2), //  _, _, _, _, _, _, _, _, _, _, _,P2,
};

const unsigned char map24[] = {
	M( _, _),M( _, _),M( _, _),M( _, _),M( _, _),M( _,P1), //  _, _, _, _, _, _, _, _, _, _, _,P1,
	M( _, _),M( W, _),M( _, _),M( _, _),M( _, _),M( _, _), //  _, _, W, _, _, _, _, _, _, _, _, _,
	M( _, _),M( W, _),M( W, C),M( _, _),M( _, _),M( _, _), //  _, _, W, _, W, C, _, _, _, _, _, _,
	M( _, _),M( W, _),M( C, _),M( C, _),M( _, _),M( _, _), //  _, _, W, _, C, _, C, _, _, _, _, _,
	M( B, F),M( W, _),M( W, C),M( _, _),M( _, _),M( _, _), //  B, F, W, _, W, C, _, _, _, _, _, _,
	M( B, B),M( W, _),M( W, C),M( _, _),M( _, _),M( _, _), //  B, B, W, _, W, C, _, _, _, _, _, _,
	M( W, B),M( B, _),M( W, C),M( _, _),M( C, C),M( _, _), //  W, B, B, _, W, C, _, _, C, C, _, _,
	M( C, W),M( B, B),M( W, _),M( _, C),M( W, C),M( _, _), //  C, W, B, B, W, _, _, C, W, C, _, _,
	M( C, C),M( W, F),M( _,RS),M( _, W),M( C, _),M( _, _), //  C, C, W, F, _,RS, _, W, C, _, _, _,
	M( _, C),M( C, B),M( C, C),M( W, C),M( _, _),M( _, _), //  _, C, C, B, C, C, W, C, _, _, _, _,
	M( G, O),M( C, B),M( C, W),M( C, _),M( _, _),M( _,P2), //  G, O, C, B, C, W, C, _, _, _, _,P2,
};

const unsigned char map25[] = {
	M(P1, _),M( _, _),M( _, _),M( _, _),M( _, _),M( _, _), // P1, _, _, _, _, _, _, _, _, _, _, _,
	M( _, _),M( G, _),M( _, _),M( _, _),M( _,WZ),M( _, _), //  _, _, G, _, _, _, _, _, _,WZ, _, _,
	M( B, B),M( B, B),M( B, B),M( B, B),M( B, B),M( B, B), //  B, B, B, B, B, B, B, B, B, B, B, B,
	M( B, B),M( C, C),M( B, B),M( B, B),M( B, B),M( B, B), //  B, B, C, C, B, B, B, B, B, B, B, B,
	M( B, B),M( C, C),M( W, B),M( B, B),M( B, B),M( B, B), //  B, B, C, C, W, B, B, B, B, B, B, B,
	M( B, B),M( B, W),M( W, B),M( B, B),M( C, C),M( B, B), //  B, B, B, W, W, B, B, B, C, C, B, B,
	M( B, B),M( B,SL),M( B, B),M( B, B),M( C, C),M( W, B), //  B, B, B,SL, B, B, B, B, C, C, W, B,
	M( B, B),M( B, B),M( B, B),M( B, B),M( B, W),M( W, B), //  B, B, B, B, B, B, B, B, B, W, W, B,
	M( F, F),M( F, F),M( F,SL),M( F, F),M( F, O),M( F, F), //  F, F, F, F, F,SL, F, F, F, O, F, F,
	M( F, F),M( F, F),M( F, F),M( F, F),M( F, F),M( F, F), //  F, F, F, F, F, F, F, F, F, F, F, F,
	M( F, F),M( F, F),M( F, F),M( F, F),M( F, F),M( F,P2), //  F, F, F, F, F, F, F, F, F, F, F,P2,
};

const unsigned char map26[] = {
	M(P1, _),M( _, _),M( _, _),M( _, _),M( _, _),M(WZ, _), // P1, _, _, _, _, _, _, _, _, _,WZ, _,
	M( _, W),M( C, W),M( C, W),M( C, W),M( W, W),M( W, _), //  _, W, C, W, C, W, C, W, W, W, W, _,
	M( _, W),M( O, W),M( _, _),M( _, _),M( _, _),M( C, _), //  _, W, O, W, _, _, _, _, _, _, C, _,
	M( _, W),M( _, _),M( _, _),M( _, W),M( _, _),M( W, _), //  _, W, _, _, _, _, _, W, _, _, W, _,
	M( _, W),M( _, _),M( _, W),M( G, _),M( _, _),M( C, _), //  _, W, _, _, _, W, G, _, _, _, C, _,
	M( _, W),M( _, _),M( _, _),M( W, _),M( _, _),M( W, _), //  _, W, _, _, _, _, W, _, _, _, W, _,
	M( _, C),M( _, _),M( _, _),M( _, _),M( W, _),M( W, _), //  _, C, _, _, _, _, _, _, W, _, W, _,
	M( _, W),M( _, _),M( W, _),M( _, _),M( _, _),M( W, _), //  _, W, _, _, W, _, _, _, _, _, W, _,
	M( _, C),M( _, _),M( _, _),M( _, _),M( _, _),M( W, _), //  _, C, _, _, _, _, _, _, _, _, W, _,
	M( _, W),M( W, W),M( W, W),M( W, C),M( W, C),M( W, _), //  _, W, W, W, W, W, W, C, W, C, W, _,
	M( _,WZ),M( _, _),M( _, _),M( _, _),M( _, _),M( _,P2), //  _,WZ, _, _, _, _, _, _, _, _, _,P2,
};

const unsigned char map27[] = {
	M(P1, _),M( B, B),M( W, F),M( F, _),M( W, W),M( W, O), // P1, _, B, B, W, F, F, _, W, W, W, O,
	M( _, _),M( W, B),M( W, F),M( W, _),M( W, _),M( _, _), //  _, _, W, B, W, F, W, _, W, _, _, _,
	M( _, _),M( W, B),M( W, F),M( W, _),M( W, C),M( _, _), //  _, _, W, B, W, F, W, _, W, C, _, _,
	M( _, _),M( W, B),M( W, F),M( W, _),M( W, _),M( _, _), //  _, _, W, B, W, F, W, _, W, _, _, _,
	M( _, _),M( W, B),M( W, F),M( W, _),M( _, _),M( _, _), //  _, _, W, B, W, F, W, _, _, _, _, _,
	M( _, _),M( W, B),M( W, F),M( W, _),M( _,SR),M( _, _), //  _, _, W, B, W, F, W, _, _,SR, _, _,
	M( _, _),M( W, B),M( W, F),M( W, _),M( C, _),M( C, _), //  _, _, W, B, W, F, W, _, C, _, C, _,
	M( _, _),M( W, B),M( W, F),M( W, _),M( C, _),M( C, _), //  _, _, W, B, W, F, W, _, C, _, C, _,
	M( _, _),M( W, B),M( W, F),M( W, _),M( W, _),M( C, C), //  _, _, W, B, W, F, W, _, W, _, C, C,
	M( _, _),M( W, B),M( W, F),M( W, _),M( C, _),M( _, _), //  _, _, W, B, W, F, W, _, C, _, _, _,
	M(P2, _),M( B, B),M( F, F),M( W, _),M( W, W),M( _, G), // P2, _, B, B, F, F, W, _, W, W, _, G,
};

const unsigned char map28[] = {
	M(P1, _),M( _, _),M( _, C),M( _, C),M( _, _),M( _, _), // P1, _, _, _, _, C, _, C, _, _, _, _,
	M( _, B),M( C, B),M( C,SL),M( C, _),M( _, _),M( _, _), //  _, B, C, B, C,SL, C, _, _, _, _, _,
	M( _, C),M( G, C),M( _, C),M( _, C),M( _, _),M( _, _), //  _, C, G, C, _, C, _, C, _, _, _, _,
	M( _, B),M( C, B),M( C, _),M( C, _),M( _, _),M( _, _), //  _, B, C, B, C, _, C, _, _, _, _, _,
	M( _, _),M( _, _),M( _, C),M( _, C),M( _, _),M( _, _), //  _, _, _, _, _, C, _, C, _, _, _, _,
	M( _, _),M( _, _),M( C,SL),M( C, _),M( _, _),M( _, _), //  _, _, _, _, C,SL, C, _, _, _, _, _,
	M( _, _),M( _, _),M( _, C),M(SL, C),M( _, _),M( _, _), //  _, _, _, _, _, C,SL, C, _, _, _, _,
	M( _, _),M( _, _),M( C, _),M( C, _),M( F, C),M( F, _), //  _, _, _, _, C, _, C, _, F, C, F, _,
	M( _, _),M( _, _),M( _, C),M( _, C),M( C, O),M( C, _), //  _, _, _, _, _, C, _, C, C, O, C, _,
	M( _, _),M( _, _),M( C, _),M( C,SL),M( F, C),M( F, _), //  _, _, _, _, C, _, C,SL, F, C, F, _,
	M( _, _),M( _, _),M( _, C),M( _, C),M( _, _),M( _,P2), //  _, _, _, _, _, C, _, C, _, _, _,P2,
};

const unsigned char map29[] = {
	M(P1, O),M( _, _),M( _, _),M( _, _),M( _, _),M( _, _), // P1, O, _, _, _, _, _, _, _, _, _, _,
	M( _, _),M( _, _),M( _, _),M( _, _),M( _, _),M( _, _), //  _, _, _, _, _, _, _, _, _, _, _, _,
	M( W, W),M( W, W),M( W, W),M( W, W),M( C, C),M( C, C), //  W, W, W, W, W, W, W, W, C, C, C, C,
	M( B, B),M( B, _),M( F, _),M( _, F),M( _, B),M( B, _), //  B, B, B, _, F, _, _, F, _, B, B, _,
	M( B, _),M( _, _),M( F, F),M( _, F),M( _, B),M( _, B), //  B, _, _, _, F, F, _, F, _, B, _, B,
	M( B, B),M( B, _),M( F, _),M( F, F),M( _, B),M( _, B), //  B, B, B, _, F, _, F, F, _, B, _, B,
	M( B, _),M( _, _),M( F, _),M( _, F),M( _, B),M( _, B), //  B, _, _, _, F, _, _, F, _, B, _, B,
	M( B, B),M(WZ, _),M(SL, _),M( _, F),M(RS, B),M( B,SR), //  B, B,WZ, _,SL, _, _, F,RS, B, B,SR,
	M( C, C),M( C, C),M( W, W),M( W, W),M( W, W),M( W, W), //  C, C, C, C, W, W, W, W, W, W, W, W,
	M( _, _),M( _, _),M( _, _),M( _, _),M( _, _),M( _, _), //  _, _, _, _, _, _, _, _, _, _, _, _,
	M( _, _),M( _, _),M( _, _),M( _, _),M( _, _),M( G,P2), //  _, _, _, _, _, _, _, _, _, _, G,P2,
};


// }bve[u
const unsigned short maps[] = {
	(unsigned short)map05,
	(unsigned short)map06,
	(unsigned short)map00,
	(unsigned short)map01,
	(unsigned short)map02,
	(unsigned short)map03,
	(unsigned short)map04,
	(unsigned short)map07,
	(unsigned short)map08,
	(unsigned short)map09,

	(unsigned short)map10,
	(unsigned short)map11,
	(unsigned short)map12,
	(unsigned short)map13,
	(unsigned short)map14,
	(unsigned short)map15,
	(unsigned short)map16,
	(unsigned short)map17,
	(unsigned short)map18,
	(unsigned short)map19,

	(unsigned short)map20,
	(unsigned short)map21,
	(unsigned short)map22,
	(unsigned short)map23,
	(unsigned short)map24,
	(unsigned short)map25,
	(unsigned short)map26,
	(unsigned short)map27,
	(unsigned short)map28,
	(unsigned short)map29,
};
