/*
 * math.h
 *
 * Last modified: <2014/12/01 20:38:38 +0900> By @MIRROR_
 */
#ifndef MATH_H_INCLUDED
#define MATH_H_INCLUDED

#include "config.h"

#define abs(_n) (((_n) < 0)? -(_n): (_n))

/*
 * CfbNXQƂ̎Op֐
 * 0`2560`2΂\B
 * `FbNȂ̂߁A0 <= rad <= 255͈̔͂ŗp邱ƁB
 */
#if defined(USE_COSTBL256) || defined(USE_COSTBL128) || defined(USE_COSTBL64)
#ifdef USE_COSTBL256
extern const char costbl[];
#define cos(rad) costbl[(unsigned char)rad]
#define sin(rad) costbl[(unsigned char)(rad-64)]
#else
char __fastcall__ cos(unsigned char rad);
char __fastcall__ sin(unsigned char rad);
#endif
char __fastcall__ tan(unsigned char rad);
#endif

/*
 * CfbNXQƂ̋tOp֐
 * atans2() y,x́A-7`0`7͈̔͂ŁB
 * USE_ATANTBL256̒`ꍇ́A-15`0`15͈̔́B
 * USE_ATANTBL144̒`ꍇ́A-11`0`11͈̔́B
 * `FbNȂ̂߁A͈͊Oł̗psȂƁB
 */
#if defined(USE_ATANTBL256) || defined(USE_ATANTBL144) || defined(USE_ATANTBL64)
char __fastcall__ atan2(char y, char x);
#endif

#ifdef USE_SQRT
/*
 * ł̌̕vZ
 * ݂̂ŁA_ȉ͂ȂB
 *
 * lZ̃ASY
 * <www001.upp.so-net.ne.jp/y_yutaka/labo/math_algo/math_algo.html>
 */
unsigned char __fastcall__ sqrt(unsigned char x);
#endif

#ifdef USE_RAND_TYPE0
/*
 * 8bitV[h̗
 */
void __fastcall__ srand(unsigned char seed);
unsigned char __fastcall__ rand(void);
#endif

#ifdef USE_RAND_TYPE1
/*
 * 8bitV[hŎ255 (= 2^8 - 1)̗
 * V[hƂ͕ʂxorshift̒萔ݒ\B
 *
 * 8bitpxorshiftASY
 * <http://blog.goo.ne.jp/sim00/e/33b576696be51efbb3eab4b5c61ffb87>
 *
 * 255ꍇ̒萔̑g݂͈ȉ̒ʂB
 *  1 : 1 1 2 (A B C̏)
 *  2 : 1 1 3
 *  3 : 1 7 3
 *  4 : 1 7 6
 *  5 : 1 7 7
 *  6 : 2 1 1
 *  7 : 2 5 5
 *  8 : 3 1 1
 *  9 : 3 1 5
 * 10 : 3 5 4
 * 11 : 3 5 5
 * 12 : 3 5 7
 * 13 : 3 7 1
 * 14 : 4 5 3
 * 15 : 5 1 3
 * 16 : 5 3 6
 * 17 : 5 3 7
 * 18 : 5 5 2
 * 19 : 5 5 3
 * 20 : 6 3 5
 * 21 : 6 7 1
 * 22 : 7 3 5
 * 23 : 7 5 3
 * 24 : 7 7 1
 */
void __fastcall__ srand(unsigned char seed);
void __fastcall__ frand(unsigned char fixed_a, unsigned char fixed_b, unsigned char fixed_c);
unsigned char __fastcall__ rand(void);
#endif

#ifdef USE_RAND_TYPE2
/*
 * 8bitx3V[hŎ16777215(=2^24-1)̗
 *
 * 8bitpxorshiftASY
 * <http://blog.goo.ne.jp/sim00/e/33b576696be51efbb3eab4b5c61ffb87>
 */
void __fastcall__ srand(unsigned char seed0, unsigned char seed1, unsigned char seed2);
unsigned char __fastcall__ rand(void);
#endif

#endif
