/*
 * title.c
 *
 * Last modified: <2014/12/30 23:24:18 +0900> By @MIRROR_
 */
#include "nes.h"
#include "game.h"

#ifdef USE_SOUND
#include "nsd.h"
#include "sound.h"
#define PLAYDEMO_START 10
#else
#define PLAYDEMO_START 5
#endif

#include "clogo_ice.h"
#include "clogo_baller.h"
#include "palette.h"


const unsigned char text_level[] = "LEVEL";
const unsigned char text_mirror[] = "Programmed by @MIRROR_";
const unsigned char text_start[] = "PRESS START BUTTON";
const unsigned char text_space[] = "                  ";

// C
void __fastcall__  TitleMain(void) {
	unsigned char frame = 0;
	unsigned char count = 0;
	unsigned char select = (game.scene > 0)? 1: 0;

	// PPȔ
	InitPPU();

#ifdef USE_SOUND
	// hCo
	nsd_init();
#endif

	// DMA
	InitDMA();

	// BG]R}ḧ揉
	InitCMD();

	// pbgݒ
	SetPalette(palettebg, 0);
	SetPalette(palettesp, 1);

	// wiݒip^[l[e[uݒj
	FillNameTbl(0, 0, BG_NAMTBL_W, BG_NAMTBL_H, 0);
	SetCprNameTbl(clogo_ice   , 0,  3, clogo_ice_W   , clogo_ice_H   , 0);
	SetCprNameTbl(clogo_baller, 2, 13, clogo_baller_W, clogo_baller_H, 0);

	SetNameTbl(text_level, (BG_NAMTBL_W-sizeof(text_level)-2)/2, 24, sizeof(text_level)-1, 1);
	SetBackgroundChar((BG_NAMTBL_W-7)/2 + 6, 24, 'A' + game.level);
	SetNameTbl(text_mirror, (BG_NAMTBL_W-sizeof(text_mirror)-1)/2, 27, sizeof(text_mirror)-1, 1);

	// wiݒ
	FillAttribute(BG1_ATTR_HADR, BG1_ATTR_LADR, 0, 64);

	// wi̕\ʒuݒ
	SetScroll(0, 0);

	// `Jn(NMI荞ݗL)
	SetPPU(0x88, 0x1e);

#ifdef USE_SOUND
	// tJn
	nsd_play_bgm(BGM_TITLE);
#endif

	game.status &= ~GAME_STATUS_PLAYDEMO;

	while (1) {

		// ݏI҂
		Sync();

		// BG]R}h
		ResetCMD();

		// DMA]\񏉊
		ResetDMA();

		// Rg[mF
		CheckPad();

		// X^[g{^
		if (ButtonDown(0, BTN_START)) {
			break;
		}

		// xI
		if (ButtonDown(0, BTN_A)) {
			game.level = 0;
			SetCMD((BG_NAMTBL_W-7)/2 + 6, 24, "A", 1);

		} else if (ButtonDown(0, BTN_B)) {
			game.level = 1;
			SetCMD((BG_NAMTBL_W-7)/2 + 6, 24, "B", 1);
		}

		// V[I
		if (select) {
			if (ButtonDown(0, BTN_LEFT)) {
				if (game.scene > 0) --game.scene;

			} else if (ButtonDown(0, BTN_RIGHT)) {
				if (game.scene < SCENE_MAX-1) ++game.scene;
			}
			sprint((SCREEN_W-7*8)/2-4, 25*8, msg_scene);
			sprint_n2((SCREEN_W-7*8)/2+6*8-4, 25*8, game.scene+1);

		} else {
			if (ButtonDown(0, BTN_SELECT)) select = 1;
		}

		// uN
		if (frame == 0) {
			SetCMD((BG_NAMTBL_W-sizeof(text_start)-1)/2, 22, text_start, sizeof(text_start)-1);

		} else if (frame == 128) {
			SetCMD((BG_NAMTBL_W-sizeof(text_start)-1)/2, 22, text_space, sizeof(text_space)-1);
		}

		// DMA]f[^ݒI
		SetEndDMA();

		// BG]f[^ݒI
		SetEndCMD();

		if (++frame == 0) {
			if (++count >= PLAYDEMO_START) {
				game.status |= GAME_STATUS_PLAYDEMO;
				break;
			}
		}
	}
}
