/*
 * vector.c
 *
 * Last modified: <2014/12/01 20:42:09 +0900> By @MIRROR_
 */
#include "vector.h"

#ifdef USE_UNITBL256
const unsigned char unitbl[16][16] = {
	{
		0x08, /* ( 0, 0)=>( 8, 0) */
		0x08, /* ( 1, 0)=>( 8, 0) */
		0x08, /* ( 2, 0)=>( 8, 0) */
		0x08, /* ( 3, 0)=>( 8, 0) */
		0x08, /* ( 4, 0)=>( 8, 0) */
		0x08, /* ( 5, 0)=>( 8, 0) */
		0x08, /* ( 6, 0)=>( 8, 0) */
		0x08, /* ( 7, 0)=>( 8, 0) */
		0x08, /* ( 8, 0)=>( 8, 0) */
		0x08, /* ( 9, 0)=>( 8, 0) */
		0x08, /* (10, 0)=>( 8, 0) */
		0x08, /* (11, 0)=>( 8, 0) */
		0x08, /* (12, 0)=>( 8, 0) */
		0x08, /* (13, 0)=>( 8, 0) */
		0x08, /* (14, 0)=>( 8, 0) */
		0x08, /* (15, 0)=>( 8, 0) */
	},
	{
		0x80, /* ( 0, 1)=>( 0, 8) */
		0x55, /* ( 1, 1)=>( 5, 5) */
		0x37, /* ( 2, 1)=>( 7, 3) */
		0x27, /* ( 3, 1)=>( 7, 2) */
		0x17, /* ( 4, 1)=>( 7, 1) */
		0x17, /* ( 5, 1)=>( 7, 1) */
		0x17, /* ( 6, 1)=>( 7, 1) */
		0x17, /* ( 7, 1)=>( 7, 1) */
		0x07, /* ( 8, 1)=>( 7, 0) */
		0x07, /* ( 9, 1)=>( 7, 0) */
		0x07, /* (10, 1)=>( 7, 0) */
		0x07, /* (11, 1)=>( 7, 0) */
		0x07, /* (12, 1)=>( 7, 0) */
		0x07, /* (13, 1)=>( 7, 0) */
		0x07, /* (14, 1)=>( 7, 0) */
		0x07, /* (15, 1)=>( 7, 0) */
	},
	{
		0x80, /* ( 0, 2)=>( 0, 8) */
		0x73, /* ( 1, 2)=>( 3, 7) */
		0x55, /* ( 2, 2)=>( 5, 5) */
		0x46, /* ( 3, 2)=>( 6, 4) */
		0x37, /* ( 4, 2)=>( 7, 3) */
		0x27, /* ( 5, 2)=>( 7, 2) */
		0x27, /* ( 6, 2)=>( 7, 2) */
		0x27, /* ( 7, 2)=>( 7, 2) */
		0x17, /* ( 8, 2)=>( 7, 1) */
		0x17, /* ( 9, 2)=>( 7, 1) */
		0x17, /* (10, 2)=>( 7, 1) */
		0x17, /* (11, 2)=>( 7, 1) */
		0x17, /* (12, 2)=>( 7, 1) */
		0x17, /* (13, 2)=>( 7, 1) */
		0x17, /* (14, 2)=>( 7, 1) */
		0x17, /* (15, 2)=>( 7, 1) */
	},
	{
		0x80, /* ( 0, 3)=>( 0, 8) */
		0x72, /* ( 1, 3)=>( 2, 7) */
		0x64, /* ( 2, 3)=>( 4, 6) */
		0x55, /* ( 3, 3)=>( 5, 5) */
		0x46, /* ( 4, 3)=>( 6, 4) */
		0x46, /* ( 5, 3)=>( 6, 4) */
		0x37, /* ( 6, 3)=>( 7, 3) */
		0x37, /* ( 7, 3)=>( 7, 3) */
		0x27, /* ( 8, 3)=>( 7, 2) */
		0x27, /* ( 9, 3)=>( 7, 2) */
		0x27, /* (10, 3)=>( 7, 2) */
		0x27, /* (11, 3)=>( 7, 2) */
		0x17, /* (12, 3)=>( 7, 1) */
		0x17, /* (13, 3)=>( 7, 1) */
		0x17, /* (14, 3)=>( 7, 1) */
		0x17, /* (15, 3)=>( 7, 1) */
	},
	{
		0x80, /* ( 0, 4)=>( 0, 8) */
		0x71, /* ( 1, 4)=>( 1, 7) */
		0x73, /* ( 2, 4)=>( 3, 7) */
		0x64, /* ( 3, 4)=>( 4, 6) */
		0x55, /* ( 4, 4)=>( 5, 5) */
		0x46, /* ( 5, 4)=>( 6, 4) */
		0x46, /* ( 6, 4)=>( 6, 4) */
		0x36, /* ( 7, 4)=>( 6, 3) */
		0x37, /* ( 8, 4)=>( 7, 3) */
		0x37, /* ( 9, 4)=>( 7, 3) */
		0x27, /* (10, 4)=>( 7, 2) */
		0x27, /* (11, 4)=>( 7, 2) */
		0x27, /* (12, 4)=>( 7, 2) */
		0x27, /* (13, 4)=>( 7, 2) */
		0x27, /* (14, 4)=>( 7, 2) */
		0x27, /* (15, 4)=>( 7, 2) */
	},
	{
		0x80, /* ( 0, 5)=>( 0, 8) */
		0x71, /* ( 1, 5)=>( 1, 7) */
		0x72, /* ( 2, 5)=>( 2, 7) */
		0x64, /* ( 3, 5)=>( 4, 6) */
		0x64, /* ( 4, 5)=>( 4, 6) */
		0x55, /* ( 5, 5)=>( 5, 5) */
		0x56, /* ( 6, 5)=>( 6, 5) */
		0x46, /* ( 7, 5)=>( 6, 4) */
		0x46, /* ( 8, 5)=>( 6, 4) */
		0x36, /* ( 9, 5)=>( 6, 3) */
		0x37, /* (10, 5)=>( 7, 3) */
		0x37, /* (11, 5)=>( 7, 3) */
		0x37, /* (12, 5)=>( 7, 3) */
		0x27, /* (13, 5)=>( 7, 2) */
		0x27, /* (14, 5)=>( 7, 2) */
		0x27, /* (15, 5)=>( 7, 2) */
	},
	{
		0x80, /* ( 0, 6)=>( 0, 8) */
		0x71, /* ( 1, 6)=>( 1, 7) */
		0x72, /* ( 2, 6)=>( 2, 7) */
		0x73, /* ( 3, 6)=>( 3, 7) */
		0x64, /* ( 4, 6)=>( 4, 6) */
		0x65, /* ( 5, 6)=>( 5, 6) */
		0x55, /* ( 6, 6)=>( 5, 5) */
		0x56, /* ( 7, 6)=>( 6, 5) */
		0x46, /* ( 8, 6)=>( 6, 4) */
		0x46, /* ( 9, 6)=>( 6, 4) */
		0x46, /* (10, 6)=>( 6, 4) */
		0x37, /* (11, 6)=>( 7, 3) */
		0x37, /* (12, 6)=>( 7, 3) */
		0x37, /* (13, 6)=>( 7, 3) */
		0x37, /* (14, 6)=>( 7, 3) */
		0x27, /* (15, 6)=>( 7, 2) */
	},
	{
		0x80, /* ( 0, 7)=>( 0, 8) */
		0x71, /* ( 1, 7)=>( 1, 7) */
		0x72, /* ( 2, 7)=>( 2, 7) */
		0x73, /* ( 3, 7)=>( 3, 7) */
		0x63, /* ( 4, 7)=>( 3, 6) */
		0x64, /* ( 5, 7)=>( 4, 6) */
		0x65, /* ( 6, 7)=>( 5, 6) */
		0x55, /* ( 7, 7)=>( 5, 5) */
		0x56, /* ( 8, 7)=>( 6, 5) */
		0x46, /* ( 9, 7)=>( 6, 4) */
		0x46, /* (10, 7)=>( 6, 4) */
		0x46, /* (11, 7)=>( 6, 4) */
		0x46, /* (12, 7)=>( 6, 4) */
		0x37, /* (13, 7)=>( 7, 3) */
		0x37, /* (14, 7)=>( 7, 3) */
		0x37, /* (15, 7)=>( 7, 3) */
	},
	{
		0x80, /* ( 0, 8)=>( 0, 8) */
		0x70, /* ( 1, 8)=>( 0, 7) */
		0x71, /* ( 2, 8)=>( 1, 7) */
		0x72, /* ( 3, 8)=>( 2, 7) */
		0x73, /* ( 4, 8)=>( 3, 7) */
		0x64, /* ( 5, 8)=>( 4, 6) */
		0x64, /* ( 6, 8)=>( 4, 6) */
		0x65, /* ( 7, 8)=>( 5, 6) */
		0x55, /* ( 8, 8)=>( 5, 5) */
		0x55, /* ( 9, 8)=>( 5, 5) */
		0x46, /* (10, 8)=>( 6, 4) */
		0x46, /* (11, 8)=>( 6, 4) */
		0x46, /* (12, 8)=>( 6, 4) */
		0x46, /* (13, 8)=>( 6, 4) */
		0x36, /* (14, 8)=>( 6, 3) */
		0x37, /* (15, 8)=>( 7, 3) */
	},
	{
		0x80, /* ( 0, 9)=>( 0, 8) */
		0x70, /* ( 1, 9)=>( 0, 7) */
		0x71, /* ( 2, 9)=>( 1, 7) */
		0x72, /* ( 3, 9)=>( 2, 7) */
		0x73, /* ( 4, 9)=>( 3, 7) */
		0x63, /* ( 5, 9)=>( 3, 6) */
		0x64, /* ( 6, 9)=>( 4, 6) */
		0x64, /* ( 7, 9)=>( 4, 6) */
		0x55, /* ( 8, 9)=>( 5, 5) */
		0x55, /* ( 9, 9)=>( 5, 5) */
		0x55, /* (10, 9)=>( 5, 5) */
		0x56, /* (11, 9)=>( 6, 5) */
		0x46, /* (12, 9)=>( 6, 4) */
		0x46, /* (13, 9)=>( 6, 4) */
		0x46, /* (14, 9)=>( 6, 4) */
		0x46, /* (15, 9)=>( 6, 4) */
	},
	{
		0x80, /* ( 0,10)=>( 0, 8) */
		0x70, /* ( 1,10)=>( 0, 7) */
		0x71, /* ( 2,10)=>( 1, 7) */
		0x72, /* ( 3,10)=>( 2, 7) */
		0x72, /* ( 4,10)=>( 2, 7) */
		0x73, /* ( 5,10)=>( 3, 7) */
		0x64, /* ( 6,10)=>( 4, 6) */
		0x64, /* ( 7,10)=>( 4, 6) */
		0x64, /* ( 8,10)=>( 4, 6) */
		0x55, /* ( 9,10)=>( 5, 5) */
		0x55, /* (10,10)=>( 5, 5) */
		0x55, /* (11,10)=>( 5, 5) */
		0x56, /* (12,10)=>( 6, 5) */
		0x46, /* (13,10)=>( 6, 4) */
		0x46, /* (14,10)=>( 6, 4) */
		0x46, /* (15,10)=>( 6, 4) */
	},
	{
		0x80, /* ( 0,11)=>( 0, 8) */
		0x70, /* ( 1,11)=>( 0, 7) */
		0x71, /* ( 2,11)=>( 1, 7) */
		0x72, /* ( 3,11)=>( 2, 7) */
		0x72, /* ( 4,11)=>( 2, 7) */
		0x73, /* ( 5,11)=>( 3, 7) */
		0x73, /* ( 6,11)=>( 3, 7) */
		0x64, /* ( 7,11)=>( 4, 6) */
		0x64, /* ( 8,11)=>( 4, 6) */
		0x65, /* ( 9,11)=>( 5, 6) */
		0x55, /* (10,11)=>( 5, 5) */
		0x55, /* (11,11)=>( 5, 5) */
		0x55, /* (12,11)=>( 5, 5) */
		0x56, /* (13,11)=>( 6, 5) */
		0x46, /* (14,11)=>( 6, 4) */
		0x46, /* (15,11)=>( 6, 4) */
	},
	{
		0x80, /* ( 0,12)=>( 0, 8) */
		0x70, /* ( 1,12)=>( 0, 7) */
		0x71, /* ( 2,12)=>( 1, 7) */
		0x71, /* ( 3,12)=>( 1, 7) */
		0x72, /* ( 4,12)=>( 2, 7) */
		0x73, /* ( 5,12)=>( 3, 7) */
		0x73, /* ( 6,12)=>( 3, 7) */
		0x64, /* ( 7,12)=>( 4, 6) */
		0x64, /* ( 8,12)=>( 4, 6) */
		0x64, /* ( 9,12)=>( 4, 6) */
		0x65, /* (10,12)=>( 5, 6) */
		0x55, /* (11,12)=>( 5, 5) */
		0x55, /* (12,12)=>( 5, 5) */
		0x55, /* (13,12)=>( 5, 5) */
		0x56, /* (14,12)=>( 6, 5) */
		0x46, /* (15,12)=>( 6, 4) */
	},
	{
		0x80, /* ( 0,13)=>( 0, 8) */
		0x70, /* ( 1,13)=>( 0, 7) */
		0x71, /* ( 2,13)=>( 1, 7) */
		0x71, /* ( 3,13)=>( 1, 7) */
		0x72, /* ( 4,13)=>( 2, 7) */
		0x72, /* ( 5,13)=>( 2, 7) */
		0x73, /* ( 6,13)=>( 3, 7) */
		0x73, /* ( 7,13)=>( 3, 7) */
		0x64, /* ( 8,13)=>( 4, 6) */
		0x64, /* ( 9,13)=>( 4, 6) */
		0x64, /* (10,13)=>( 4, 6) */
		0x65, /* (11,13)=>( 5, 6) */
		0x55, /* (12,13)=>( 5, 5) */
		0x55, /* (13,13)=>( 5, 5) */
		0x55, /* (14,13)=>( 5, 5) */
		0x56, /* (15,13)=>( 6, 5) */
	},
	{
		0x80, /* ( 0,14)=>( 0, 8) */
		0x70, /* ( 1,14)=>( 0, 7) */
		0x71, /* ( 2,14)=>( 1, 7) */
		0x71, /* ( 3,14)=>( 1, 7) */
		0x72, /* ( 4,14)=>( 2, 7) */
		0x72, /* ( 5,14)=>( 2, 7) */
		0x73, /* ( 6,14)=>( 3, 7) */
		0x73, /* ( 7,14)=>( 3, 7) */
		0x63, /* ( 8,14)=>( 3, 6) */
		0x64, /* ( 9,14)=>( 4, 6) */
		0x64, /* (10,14)=>( 4, 6) */
		0x64, /* (11,14)=>( 4, 6) */
		0x65, /* (12,14)=>( 5, 6) */
		0x55, /* (13,14)=>( 5, 5) */
		0x55, /* (14,14)=>( 5, 5) */
		0x55, /* (15,14)=>( 5, 5) */
	},
	{
		0x80, /* ( 0,15)=>( 0, 8) */
		0x70, /* ( 1,15)=>( 0, 7) */
		0x71, /* ( 2,15)=>( 1, 7) */
		0x71, /* ( 3,15)=>( 1, 7) */
		0x72, /* ( 4,15)=>( 2, 7) */
		0x72, /* ( 5,15)=>( 2, 7) */
		0x72, /* ( 6,15)=>( 2, 7) */
		0x73, /* ( 7,15)=>( 3, 7) */
		0x73, /* ( 8,15)=>( 3, 7) */
		0x64, /* ( 9,15)=>( 4, 6) */
		0x64, /* (10,15)=>( 4, 6) */
		0x64, /* (11,15)=>( 4, 6) */
		0x64, /* (12,15)=>( 4, 6) */
		0x65, /* (13,15)=>( 5, 6) */
		0x55, /* (14,15)=>( 5, 5) */
		0x55, /* (15,15)=>( 5, 5) */
	},
};
#endif

#ifdef USE_UNITBL144
const unsigned char unitbl[12][12] = {
	{
		0x08, /* ( 0, 0)=>( 8, 0) */
		0x08, /* ( 1, 0)=>( 8, 0) */
		0x08, /* ( 2, 0)=>( 8, 0) */
		0x08, /* ( 3, 0)=>( 8, 0) */
		0x08, /* ( 4, 0)=>( 8, 0) */
		0x08, /* ( 5, 0)=>( 8, 0) */
		0x08, /* ( 6, 0)=>( 8, 0) */
		0x08, /* ( 7, 0)=>( 8, 0) */
		0x08, /* ( 8, 0)=>( 8, 0) */
		0x08, /* ( 9, 0)=>( 8, 0) */
		0x08, /* (10, 0)=>( 8, 0) */
		0x08, /* (11, 0)=>( 8, 0) */
	},
	{
		0x80, /* ( 0, 1)=>( 0, 8) */
		0x55, /* ( 1, 1)=>( 5, 5) */
		0x37, /* ( 2, 1)=>( 7, 3) */
		0x27, /* ( 3, 1)=>( 7, 2) */
		0x17, /* ( 4, 1)=>( 7, 1) */
		0x17, /* ( 5, 1)=>( 7, 1) */
		0x17, /* ( 6, 1)=>( 7, 1) */
		0x17, /* ( 7, 1)=>( 7, 1) */
		0x07, /* ( 8, 1)=>( 7, 0) */
		0x07, /* ( 9, 1)=>( 7, 0) */
		0x07, /* (10, 1)=>( 7, 0) */
		0x07, /* (11, 1)=>( 7, 0) */
	},
	{
		0x80, /* ( 0, 2)=>( 0, 8) */
		0x73, /* ( 1, 2)=>( 3, 7) */
		0x55, /* ( 2, 2)=>( 5, 5) */
		0x46, /* ( 3, 2)=>( 6, 4) */
		0x37, /* ( 4, 2)=>( 7, 3) */
		0x27, /* ( 5, 2)=>( 7, 2) */
		0x27, /* ( 6, 2)=>( 7, 2) */
		0x27, /* ( 7, 2)=>( 7, 2) */
		0x17, /* ( 8, 2)=>( 7, 1) */
		0x17, /* ( 9, 2)=>( 7, 1) */
		0x17, /* (10, 2)=>( 7, 1) */
		0x17, /* (11, 2)=>( 7, 1) */
	},
	{
		0x80, /* ( 0, 3)=>( 0, 8) */
		0x72, /* ( 1, 3)=>( 2, 7) */
		0x64, /* ( 2, 3)=>( 4, 6) */
		0x55, /* ( 3, 3)=>( 5, 5) */
		0x46, /* ( 4, 3)=>( 6, 4) */
		0x46, /* ( 5, 3)=>( 6, 4) */
		0x37, /* ( 6, 3)=>( 7, 3) */
		0x37, /* ( 7, 3)=>( 7, 3) */
		0x27, /* ( 8, 3)=>( 7, 2) */
		0x27, /* ( 9, 3)=>( 7, 2) */
		0x27, /* (10, 3)=>( 7, 2) */
		0x27, /* (11, 3)=>( 7, 2) */
	},
	{
		0x80, /* ( 0, 4)=>( 0, 8) */
		0x71, /* ( 1, 4)=>( 1, 7) */
		0x73, /* ( 2, 4)=>( 3, 7) */
		0x64, /* ( 3, 4)=>( 4, 6) */
		0x55, /* ( 4, 4)=>( 5, 5) */
		0x46, /* ( 5, 4)=>( 6, 4) */
		0x46, /* ( 6, 4)=>( 6, 4) */
		0x36, /* ( 7, 4)=>( 6, 3) */
		0x37, /* ( 8, 4)=>( 7, 3) */
		0x37, /* ( 9, 4)=>( 7, 3) */
		0x27, /* (10, 4)=>( 7, 2) */
		0x27, /* (11, 4)=>( 7, 2) */
	},
	{
		0x80, /* ( 0, 5)=>( 0, 8) */
		0x71, /* ( 1, 5)=>( 1, 7) */
		0x72, /* ( 2, 5)=>( 2, 7) */
		0x64, /* ( 3, 5)=>( 4, 6) */
		0x64, /* ( 4, 5)=>( 4, 6) */
		0x55, /* ( 5, 5)=>( 5, 5) */
		0x56, /* ( 6, 5)=>( 6, 5) */
		0x46, /* ( 7, 5)=>( 6, 4) */
		0x46, /* ( 8, 5)=>( 6, 4) */
		0x36, /* ( 9, 5)=>( 6, 3) */
		0x37, /* (10, 5)=>( 7, 3) */
		0x37, /* (11, 5)=>( 7, 3) */
	},
	{
		0x80, /* ( 0, 6)=>( 0, 8) */
		0x71, /* ( 1, 6)=>( 1, 7) */
		0x72, /* ( 2, 6)=>( 2, 7) */
		0x73, /* ( 3, 6)=>( 3, 7) */
		0x64, /* ( 4, 6)=>( 4, 6) */
		0x65, /* ( 5, 6)=>( 5, 6) */
		0x55, /* ( 6, 6)=>( 5, 5) */
		0x56, /* ( 7, 6)=>( 6, 5) */
		0x46, /* ( 8, 6)=>( 6, 4) */
		0x46, /* ( 9, 6)=>( 6, 4) */
		0x46, /* (10, 6)=>( 6, 4) */
		0x37, /* (11, 6)=>( 7, 3) */
	},
	{
		0x80, /* ( 0, 7)=>( 0, 8) */
		0x71, /* ( 1, 7)=>( 1, 7) */
		0x72, /* ( 2, 7)=>( 2, 7) */
		0x73, /* ( 3, 7)=>( 3, 7) */
		0x63, /* ( 4, 7)=>( 3, 6) */
		0x64, /* ( 5, 7)=>( 4, 6) */
		0x65, /* ( 6, 7)=>( 5, 6) */
		0x55, /* ( 7, 7)=>( 5, 5) */
		0x56, /* ( 8, 7)=>( 6, 5) */
		0x46, /* ( 9, 7)=>( 6, 4) */
		0x46, /* (10, 7)=>( 6, 4) */
		0x46, /* (11, 7)=>( 6, 4) */
	},
	{
		0x80, /* ( 0, 8)=>( 0, 8) */
		0x70, /* ( 1, 8)=>( 0, 7) */
		0x71, /* ( 2, 8)=>( 1, 7) */
		0x72, /* ( 3, 8)=>( 2, 7) */
		0x73, /* ( 4, 8)=>( 3, 7) */
		0x64, /* ( 5, 8)=>( 4, 6) */
		0x64, /* ( 6, 8)=>( 4, 6) */
		0x65, /* ( 7, 8)=>( 5, 6) */
		0x55, /* ( 8, 8)=>( 5, 5) */
		0x55, /* ( 9, 8)=>( 5, 5) */
		0x46, /* (10, 8)=>( 6, 4) */
		0x46, /* (11, 8)=>( 6, 4) */
	},
	{
		0x80, /* ( 0, 9)=>( 0, 8) */
		0x70, /* ( 1, 9)=>( 0, 7) */
		0x71, /* ( 2, 9)=>( 1, 7) */
		0x72, /* ( 3, 9)=>( 2, 7) */
		0x73, /* ( 4, 9)=>( 3, 7) */
		0x63, /* ( 5, 9)=>( 3, 6) */
		0x64, /* ( 6, 9)=>( 4, 6) */
		0x64, /* ( 7, 9)=>( 4, 6) */
		0x55, /* ( 8, 9)=>( 5, 5) */
		0x55, /* ( 9, 9)=>( 5, 5) */
		0x55, /* (10, 9)=>( 5, 5) */
		0x56, /* (11, 9)=>( 6, 5) */
	},
	{
		0x80, /* ( 0,10)=>( 0, 8) */
		0x70, /* ( 1,10)=>( 0, 7) */
		0x71, /* ( 2,10)=>( 1, 7) */
		0x72, /* ( 3,10)=>( 2, 7) */
		0x72, /* ( 4,10)=>( 2, 7) */
		0x73, /* ( 5,10)=>( 3, 7) */
		0x64, /* ( 6,10)=>( 4, 6) */
		0x64, /* ( 7,10)=>( 4, 6) */
		0x64, /* ( 8,10)=>( 4, 6) */
		0x55, /* ( 9,10)=>( 5, 5) */
		0x55, /* (10,10)=>( 5, 5) */
		0x55, /* (11,10)=>( 5, 5) */
	},
	{
		0x80, /* ( 0,11)=>( 0, 8) */
		0x70, /* ( 1,11)=>( 0, 7) */
		0x71, /* ( 2,11)=>( 1, 7) */
		0x72, /* ( 3,11)=>( 2, 7) */
		0x72, /* ( 4,11)=>( 2, 7) */
		0x73, /* ( 5,11)=>( 3, 7) */
		0x73, /* ( 6,11)=>( 3, 7) */
		0x64, /* ( 7,11)=>( 4, 6) */
		0x64, /* ( 8,11)=>( 4, 6) */
		0x65, /* ( 9,11)=>( 5, 6) */
		0x55, /* (10,11)=>( 5, 5) */
		0x55, /* (11,11)=>( 5, 5) */
	},
};
#endif

#ifdef USE_UNITBL64
const unsigned char unitbl[8][8] = {
	{
		0x08, /* ( 0, 0)=>( 8, 0) */
		0x08, /* ( 1, 0)=>( 8, 0) */
		0x08, /* ( 2, 0)=>( 8, 0) */
		0x08, /* ( 3, 0)=>( 8, 0) */
		0x08, /* ( 4, 0)=>( 8, 0) */
		0x08, /* ( 5, 0)=>( 8, 0) */
		0x08, /* ( 6, 0)=>( 8, 0) */
		0x08, /* ( 7, 0)=>( 8, 0) */
	},
	{
		0x80, /* ( 0, 1)=>( 0, 8) */
		0x55, /* ( 1, 1)=>( 5, 5) */
		0x37, /* ( 2, 1)=>( 7, 3) */
		0x27, /* ( 3, 1)=>( 7, 2) */
		0x17, /* ( 4, 1)=>( 7, 1) */
		0x17, /* ( 5, 1)=>( 7, 1) */
		0x17, /* ( 6, 1)=>( 7, 1) */
		0x17, /* ( 7, 1)=>( 7, 1) */
	},
	{
		0x80, /* ( 0, 2)=>( 0, 8) */
		0x73, /* ( 1, 2)=>( 3, 7) */
		0x55, /* ( 2, 2)=>( 5, 5) */
		0x46, /* ( 3, 2)=>( 6, 4) */
		0x37, /* ( 4, 2)=>( 7, 3) */
		0x27, /* ( 5, 2)=>( 7, 2) */
		0x27, /* ( 6, 2)=>( 7, 2) */
		0x27, /* ( 7, 2)=>( 7, 2) */
	},
	{
		0x80, /* ( 0, 3)=>( 0, 8) */
		0x72, /* ( 1, 3)=>( 2, 7) */
		0x64, /* ( 2, 3)=>( 4, 6) */
		0x55, /* ( 3, 3)=>( 5, 5) */
		0x46, /* ( 4, 3)=>( 6, 4) */
		0x46, /* ( 5, 3)=>( 6, 4) */
		0x37, /* ( 6, 3)=>( 7, 3) */
		0x37, /* ( 7, 3)=>( 7, 3) */
	},
	{
		0x80, /* ( 0, 4)=>( 0, 8) */
		0x71, /* ( 1, 4)=>( 1, 7) */
		0x73, /* ( 2, 4)=>( 3, 7) */
		0x64, /* ( 3, 4)=>( 4, 6) */
		0x55, /* ( 4, 4)=>( 5, 5) */
		0x46, /* ( 5, 4)=>( 6, 4) */
		0x46, /* ( 6, 4)=>( 6, 4) */
		0x36, /* ( 7, 4)=>( 6, 3) */
	},
	{
		0x80, /* ( 0, 5)=>( 0, 8) */
		0x71, /* ( 1, 5)=>( 1, 7) */
		0x72, /* ( 2, 5)=>( 2, 7) */
		0x64, /* ( 3, 5)=>( 4, 6) */
		0x64, /* ( 4, 5)=>( 4, 6) */
		0x55, /* ( 5, 5)=>( 5, 5) */
		0x56, /* ( 6, 5)=>( 6, 5) */
		0x46, /* ( 7, 5)=>( 6, 4) */
	},
	{
		0x80, /* ( 0, 6)=>( 0, 8) */
		0x71, /* ( 1, 6)=>( 1, 7) */
		0x72, /* ( 2, 6)=>( 2, 7) */
		0x73, /* ( 3, 6)=>( 3, 7) */
		0x64, /* ( 4, 6)=>( 4, 6) */
		0x65, /* ( 5, 6)=>( 5, 6) */
		0x55, /* ( 6, 6)=>( 5, 5) */
		0x56, /* ( 7, 6)=>( 6, 5) */
	},
	{
		0x80, /* ( 0, 7)=>( 0, 8) */
		0x71, /* ( 1, 7)=>( 1, 7) */
		0x72, /* ( 2, 7)=>( 2, 7) */
		0x73, /* ( 3, 7)=>( 3, 7) */
		0x63, /* ( 4, 7)=>( 3, 6) */
		0x64, /* ( 5, 7)=>( 4, 6) */
		0x65, /* ( 6, 7)=>( 5, 6) */
		0x55, /* ( 7, 7)=>( 5, 5) */
	},
};
#endif

#if defined(USE_UNITBL256) || defined(USE_UNITBL144) || defined(USE_UNITBL64)
void __fastcall__ normal(Vector *vec) {
	char x = vec->x;
	char y = vec->y;
	unsigned char d;

	if (y < 0) {
		y = -y;
		if (x < 0) {
			// 3ی
			x = -x;
			d = unitbl[y][x];
			vec->y = -((d >> 4) & 0x0f);
			vec->x = -(d & 0x0f);
		} else {
			// 2ی
			d = unitbl[y][x];
			vec->y = -((d >> 4) & 0x0f);
			vec->x = d & 0x0f;
		}
	} else {
		if (x < 0) {
			// 4ی
			x = -x;
			d = unitbl[y][x];
			vec->y =  (d >> 4) & 0x0f;
			vec->x = -(d & 0x0f);
		} else {
			// 1ی
			d = unitbl[y][x];
			vec->y = (d >> 4) & 0x0f;
			vec->x = d & 0x0f;
		}
	}
}
#endif
